/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("carter.ui.PublishMenu");

dojo.require("carter.ui.publisher.NewPublishEditorInput");
dojo.require("carter.ui.publisher.ManageModelsEditorInput");
dojo.require("carter.ui.editors.DefinitionsEditorInput");
dojo.require("carter.ui.editors.ActivitiesEditorInput");
dojo.require("carter.ui.utils");

dojo.require("rmps.app.ui.EditorUtil");

dojo.require("jazz.app._ComponentMenu");
dojo.require("jazz.app.context");

dojo.require("dojo.i18n");
dojo.requireLocalization("carter.ui", "EditorMessages");
var messages = dojo.i18n.getLocalization("carter.ui", "EditorMessages");

var PAGE_ID = "carter.ui.publish";

dojo.declare("carter.ui.PublishMenu", jazz.app._ComponentMenu, {
	
	postCreate: function() {
			
    	var projectId = jazz.app.context.get().itemId;
    	var PublishEditorInput = new carter.ui.publisher.NewPublishEditorInput({ projectId: projectId });
    	var MMEditorInput = new carter.ui.publisher.ManageModelsEditorInput({ projectId: projectId });
    	var DefinitionsInput = new carter.ui.editors.DefinitionsEditorInput({ projectId: projectId });
    	var ActivitiesInput = new carter.ui.editors.ActivitiesEditorInput({ projectId: projectId });
    	
		this.addTitle(messages.rhapsodyImport);
		
		this.addItemByArgs({
				editorInput: PublishEditorInput,
				label: DefinitionsInput.getName(),
				icon: DefinitionsInput.getIconUri(),
				href: DefinitionsInput.getPresentationUri() 
			});
		this.addItemByArgs({
				editorInput: PublishEditorInput,
				label: PublishEditorInput.getName(),
				icon: PublishEditorInput.getIconUri(),
				href: PublishEditorInput.getPresentationUri() 
			});
		this.addItemByArgs({
				editorInput: MMEditorInput,
				label: MMEditorInput.getName(),
				icon: MMEditorInput.getIconUri(),
				href: MMEditorInput.getPresentationUri()
			});
		this.addItemByArgs({
				editorInput: ActivitiesInput,
				label: ActivitiesInput.getName(),
				icon: ActivitiesInput.getIconUri(),
				href: ActivitiesInput.getPresentationUri()
			});
	},
	
	getSelected: function() {
		var sel = [];
		if (net.jazz.ajax.ui.PlatformUI.getWorkbench().currentPageId == PAGE_ID) {
			var editorUtil = rmps.app.ui.EditorUtil.getInstance(PAGE_ID);
			var aei = editorUtil.getActiveEditorInput();
			var items = this.getItems();
			var href = location.href;
			for (var i = 0; i < items.length; i++) {
				var item = items[i];
				if (item && (item.editorInput && item.editorInput.getId() === aei.getId() || (item.href && href.indexOf(item.href) > 0))) {
					sel.push(item);
				}
			}
		}
		return sel;
	}
});
})();