/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2010.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
(function() {
    dojo.provide("carter.ui.PublishWidgetController");

    dojo.declare("carter.ui.PublishWidgetController", null, {

        // private properties
        _page: null,

        _defaultUrl: null,

        constructor: function(page) {
            this._page = page;
        },

        _default: function(args) {
            if (this._defaultUrl) {
                setTimeout(dojo.hitch(this, function() {
                    window.location.href = this._defaultUrl;
                }), 0);
                return;
            }
            this.viewNewPublish(args);
        },

        _getEditorArgs: function(args) {
            var rest = dojo.clone(args);
            delete rest.action;
            delete rest.id;
            return rest;
        },

        viewNewPublish: function(args) {
            this._defaultUrl = window.location.href;
            this._page.showNewPublishView(this._getEditorArgs(args));
        },
		
		viewManageModels: function(args) {
			this._defaultUrl = window.location.href;
			this._page.showManageModelsView(this._getEditorArgs(args));
		},
		
		viewDefinitions: function(args) {
			this._defaultUrl = window.location.href;
			this._page.showDefinitionsView(this._getEditorArgs(args));
		},
		
		viewDefinitionEditor: function(args) {
			this._defaultUrl = window.location.href;
			this._page.showDefinitionEditor(this._getEditorArgs(args));
		},		

		viewActivities: function(args) {
			this._defaultUrl = window.location.href;
			this._page.showActivitiesEditor(this._getEditorArgs(args));
		}		
				
				
    });

})();
