/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2010.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
(function() {

	dojo.provide("carter.ui.RootServices");

    dojo.require("dojox.xml.DomParser");
    dojo.require("jazz.client.xhr");

	dojo.require("dojo.i18n");
	
	dojo.requireLocalization("carter.ui", "PublisherMessages");
	
	var messages = dojo.i18n.getLocalization("carter.ui", "PublisherMessages");

    carter.ui.Namespaces = {
    	RDF: "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
        CARTER_1_0: "http://ibm.com/carter/1.0/"
    };

    // mixin the latest version 
    dojo.mixin(carter.ui.Namespaces, {
        CARTER: carter.ui.Namespaces.CARTER_1_0
    });

    dojo.declare("carter.ui._RootServices", null, {

        constructor: function(doc) {
            this._doc = doc;
            this._rdfPrefix = this._getPrefix("http://www.w3.org/1999/02/22-rdf-syntax-ns#");
        },
    
        _getPrefix: function(namespace) {        	
            for (var key in this._doc.namespaces) {
                var n = this._doc.namespaces[key];
                if (n === namespace) {
                    return key;
                }
            }
            return null;
        },
   
   
        getUri: function(namespace, name) {
            var prefix = this._getPrefix(namespace);
            if (!prefix) {
                throw new Error(messages.err_RootServices_noEntry + namespace + name);
            }

            var element = this._doc.getElementsByTagName(prefix + ":" + name)[0];
            if (!element) {
                throw new Error(messages.err_RootServices_noEntry + namespace + name);
            }
            
            return element.getAttribute(this._rdfPrefix + ":resource");
        }
 
    });
    
    jazz.client.xhrGet({
    	url: net.jazz.ajax._contextRoot + "/rootservices",
    	handleAs: "text",
    	load: function(response, ioArgs) {
    		carter.ui.RootServices = new carter.ui._RootServices(dojox.xml.DomParser.parse(response));
    	},
    	sync: true
    });
})();