/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.rational.carter.ide.client.clm.ClmWidget");


function noError(){return false;}

/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");

/*######################################### */
// declare dependencies on other Dojo modules
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.hash");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("rmps.ui.commenting.CommentingWidget");
dojo.require("com.ibm.rational.carter.ide.client.comment.RhpCommentingWidget");
dojo.require("rmps.app.ui.internal.editors.views.Links");
dojo.require("com.ibm.rational.carter.ide.client.links.RhpLinks");

dojo.require("rmps.core.resource.Resource");
dojo.require("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");

dojo.require("rmps.core.user.User");
dojo.require("com.ibm.rational.carter.ide.client.user.RhpUserClient");

dojo.require("rmps.core.RootServices");

dojo.require("dojo.cookie");

dojo.require("rmps.core.TaskMonitor");

dojo.require("rmps.app.ui.internal.comment.SketchContribution");

dojo.require("jazz.ui.MessageBox");
dojo.require("jazz.ui.SimpleToolbar");
dojo.require("rmps.ui.SimpleButton");

dojo.require("dojox.html.entities");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpSubscribeButton");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
 

dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.app.ui.internal.dialogs.AddCALMLinksDialog");

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
dojo.requireLocalization("rmps.app.ui.internal.editors", "BaseEditorMessages");
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");

dojo.require("rmps.ui.resource.ResourceIconLabel");

dojo.require("com.ibm.rational.carter.ide.client.header.headerWidget");


var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.editors", "BaseEditorMessages");

var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

var UserClient = com.ibm.rational.carter.ide.client.user.RhpUserClient;
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;
var ResourceInfoClient = com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient;
var ConnectionInfo = com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo;
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

var DEFAULT = "default";

// declare and implement the widget "class"
dojo.declare("com.ibm.rational.carter.ide.client.clm.ClmWidget", [ dijit._Widget, dijit._Templated ], {
    templatePath: dojo.moduleUrl("com.ibm.rational.carter.ide.client", "clm/templates/clmWidget.html"),
    
	// properties
	commentingWidget: null,
	linkWidget: null,
	connectionWidget: null,
	
	_user:null,
	_resource:null,
	_projectArea:null,
	
	_commentsPane:null,
	_linksPane:null,
	_projectAreaPane:null,
	
	_tabContainer:null,
	_selectedTab:null,
	
	_headerWidget: null,
	
	_headerContent2: null,
	
	_resourceNameLbl: null,
	
	
	_toolbarContainer:null,
	toolbar:null,
	messageBox:null,
	refreshButton:null,
	saveButton:null,
	relatedElementsButton:null,
	subscriptionButtonController:null,
	
	// private properties
	_dirtyGroups: null, //{}
	_dirtyIndicator: null,
	
	_oldHash: null,
	
	_cookiesSet:true,
	
	constructor: function() {
		window.onerror = noError;
		this._dirtyGroups = {};
		this._oldHash = dojo.queryToObject(dojo.hash());
	},

	initAfterCookiesSet: function()
	{
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.initUser);
		deferred.addCallback(this,this.initResource);
		deferred.addCallback(this,this.initSettingsFromFragment);
		//connection widget should refresh
		deferred.addCallback(this,this.removeConnectionWidget);
		deferred.addCallback(this,this.createConnectionWidget);
		//deferred.addCallback(this,this.backupCookies);
		return deferred;

	},
	backupCookies: function(){
		
		//dojo.cookie("configObj", "expiresk");
		//var check = dojo.cookie("configObj");
		//var sessionID = dojo.fromJson(dojo.cookie("JSESSIONID"));
		//sessionID = 45;
		
		
		
	},
	initCookies: function()
	{
		if (this._cookiesSet == false) {
			this._cookiesSet = ConnectionInfo.setConnectionCookies();
			if (this._cookiesSet) 
				this.initAfterCookiesSet();
		}
		return this._cookiesSet;
	},
    
	postCreate: function() {
		
		//triggers the login window if needed
		if (RhpCommunicator.login() == false)
			return;

		this.createTabContainer();

		
		this.initAfterCookiesSet();
        
		this.inherited(arguments);
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");
     },

	updateFragment: function(newFragment) {
    
		//change the hash to redirect
		var oldHash = dojo.hash();
		var oldHashObj = dojo.queryToObject(oldHash);
		var newHashObj = dojo.mixin(oldHashObj, newFragment);
		var location = window.location;
		var stringL = new String(location);
		var newLocation = stringL.substring(0, stringL.lastIndexOf('#') + 1);
		this._oldHash = dojo.mixin({}, newHashObj);//dojo.clone(newHashObj);
		RhpCommunicator.setWindowLocation(newLocation + dojo.objectToQuery(newHashObj));
	},

	
	onHashChange: function(hash) {
		var newHash = (hash != null)? hash : dojo.hash();
		var newHashObj = dojo.queryToObject(newHash);


		if (newHashObj.projectName != this._oldHash.projectName
			|| newHashObj.resourceId != this._oldHash.resourceId)
		{
			//onResourceChanged
			var deferred = this.initResource();
			if (deferred != null)
			{
				deferred.addCallback(this,this.initSettingsFromFragment);
				deferred.addCallback(this,this.onResourceChange);
			}
		}
		if (newHashObj.tab != this._oldHash.tab) {
			if (newHashObj.tab == null)
				newHashObj.tab = this._oldHash.tab;
			this.initTab(newHashObj.tab);
		}

		
		this._oldHash = dojo.mixin({}, newHashObj);//dojo.clone(newHashObj);
	},
	
	onResourceChange: function()	{
		
		//link widget should be recreated
		this.removeLinkWidget();
		this.createLinkWidget();
		
		this.removeCommentingWidget();
		this.createCommentingWidget();
		
		this.removeConnectionWidget();
		this.createConnectionWidget();
		
		this._clearDirty();
		
		if (this.subscriptionButtonController != null)
			this.subscriptionButtonController.update(this.toolbar, this._resource, this._user, this);
		this.hideMessageArea();
		
		this.updateHeader();
	},
	
	updateHeader: function() {
		if (this._headerWidget == null)
		{
			this._headerWidget = new com.ibm.rational.carter.ide.client.header.headerWidget();
			this._headerContent2.appendChild(this._headerWidget.domNode);
			this._resourceNameLbl.innerHTML = "";
		}
		if (this._headerWidget == null)
			return;
		this._headerWidget.setResource(this._resource);
	},
	
	initUser: function() {
		
		//get userUri
		var deferred = UserClient.whoAmI();
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._user = user;
		}));
		return deferred;
		
	},
	setBaseUrlAccordingToProjectArea: function(){
		if (this._projectArea != null){
			var currentBaseUrl = document.getElementsByTagName("base")[0].getAttribute("href");
			var PROJECT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "projects");
			PROJECT_PATH = PROJECT_PATH.replace("projects","web/projects");
			var newBaseUrl = PROJECT_PATH + "/" + this._projectArea.name;
			document.getElementsByTagName("base")[0].setAttribute("href",newBaseUrl);
			currentBaseUrl = document.getElementsByTagName("base")[0].getAttribute("href");
			
		}

		var y = 15;
		
	},
	
	setThisProjectArea: function (pa) {
		this._projectArea = pa;
		RhpCommunicator.notifyRhapsody({
				cmd: "projectareaselected",
				params: (this._projectArea != null)?[this._projectArea.name]:[],
			});

	},
	setResource: function(resource) {
		this._resource = resource;
		this.initSettingsFromFragment();
		this.onResourceChange();
		
		
	},
	initResource: function() {
		//set project Area		
		//get the Project Id from the fragment
		var projectName = this.getFragment("projectName");
		this._projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);
		var modelName = this.getFragment("modelName");
		var resourceId = this.getFragment("resourceId");
		
		//that has this resource published
		if (this._projectArea != null)
		{
			this.setThisProjectArea(this._projectArea);
			this.setBaseUrlAccordingToProjectArea();
			var MODELS_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "models");
			
			var resourceUri = MODELS_PATH +
				"/" + this._projectArea.itemId +
				"/" + this._projectArea.groupId +
				"/" + modelName +
				"/" + resourceId;
			var deferred = ResourceInfoClient.getResourceInfo(resourceUri);
			deferred.addCallback(this, function(infos){
					this.setResource( (infos != null)? infos[0]:null);
				});
			deferred.addErrback(this,function(err){
				this.setResource(null);
			});
			return deferred;
		}
		else {
			
			var deferred = RhpProjectAreaInfo.getDefaultProjectAreas(resourceId,modelName);
			deferred.addCallback(this, function(resourceInfo) {
				var info;
				if(dojo.isArray(resourceInfo)){
					info= resourceInfo[0];
				}else{
					info= resourceInfo;
				}
				this.setResource(info);
				if (this._resource != null) {
					this.setThisProjectArea(RhpProjectAreaInfo.getProjectAreaByUrl(
									this._resource.resourceContext));
					this.setBaseUrlAccordingToProjectArea();
				}
			});
			deferred.addErrback(this,function(err){
				var y  = err;
			});
			return deferred;
		}
		return null;
	},
	
	initSettingsFromFragment: function() {

		if (this._projectArea != null) {
			//set project-area Uri for jazz.app.currentApplication.context as the widget is looking for it.
			dojo.getObject("currentApplication", true, jazz.app).context = this._projectArea.url;
			jazz.app.context.set(this._projectArea);
			
			net.jazz.ajax.ui.PlatformUI._workbench = this;
			
			this.createToolbar();
			this.initTab();
		}
	},
	
	createToolbar: function()
	{
		if (this.toolbar != null)
			return; 
		
		// message box
		this.messageBox = new jazz.ui.MessageBox();
		//this.connect(this.messageBox, "_toggleDetails", this._toggleDetails);
		//this.connect(this.messageBox, "hideMessage", this._hideMessage);
		//this.connect(this.messageBox.domNode, "onmouseenter", this._resetMessageCloseDelay);
		//this.connect(this.messageBox.domNode, "onmouseleave", this._startMessageCloseDelay);
		this._toolbarContainer.appendChild(this.messageBox.domNode);
		
		// toolbar
		this.toolbar = new jazz.ui.SimpleToolbar();
		this.toolbar.containerNode = this.toolbar.domNode;
		
		if (dojo.isIE < 8) {
			this._toolbarContainer.insertBefore(this.toolbar.domNode, this.messageBox.domNode);
		} else {
			this._toolbarContainer.appendChild(this.toolbar.domNode);
		}
		this.addButtons(this.toolbar);
	},

	addButtons: function(toolbar) {
		
		this.saveButton = toolbar.addWidget(new rmps.ui.SimpleButton({
					label: commonMessages.save,
					onClick: dojo.hitch(this, this.save)
				}));
			this.saveButton.setEnabled(false);
		/*this.relatedElementsButton = toolbar.addWidget(new rmps.ui.SimpleButton({
					label: rhpMessages.relatedElements,
					onClick: dojo.hitch(this, function () {
						if (this._resource != null) {
							RhpCommunicator.notifyRhapsody({
								cmd: "showRelatedElements",
								params: (this._resource != null) ? [this._resource.uri, this._resource.shortName] : []
							});
						}
					})
				}));
			this.relatedElementsButton.setEnabled(true);*/
		
		this.refreshButton = toolbar.addButton(this, this._onRefresh, {
				label: commonMessages.refresh,
				imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/refresh.gif")
			});	
		// subscriptions
		this.subscriptionButtonController = com.ibm.rational.carter.ide.client.internal.RhpSubscribeButton;
		this.subscriptionButtonController.init(toolbar, this._resource, this._user, this);

	},
	

	removeConnectionWidget: function() {
		// clear whatever was previously displayed && display new widget
        if (this.connectionWidget != null)
		{
			this.connectionWidget.destroy();
			 this.connectionWidget = null;
		}
		while(this._projectAreaPane.domNode.hasChildNodes()){
            this._projectAreaPane.domNode.removeChild(this._projectAreaPane.domNode.firstChild);
        }	
		
	},
	
	createConnectionWidget: function()
	{
		if (this._selectedTab != this._projectAreaPane)
			return;
			
		if (this.connectionWidget != null)
			return;
		
		var pane  = this._projectAreaPane.domNode;

		this.connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget(
							{_clmWidget: this,});
		pane.appendChild(this.connectionWidget.domNode);
		dojo.connect(this.connectionWidget, "_onSelectProject",this,function(projectName){
			if (projectName!= "") {
				RhpCommunicator.notifyRhapsody({
					cmd: "projectareachange",
					params:[projectName]
				});
				/*var location = "connection://$projectareachange";
				location += "$rhps ep" + projectName;
				//update property in model
				//this.setWindowLocation(location);*/
				
				//change the hash to redirect
				this.updateFragment({projectName:projectName},true);
				var deferred = this.initResource();
				if (deferred != null)
				{
					deferred.addCallback(this,this.onResourceChange);
				}

			}
		}); 
	},

	createTabContainer: function()
	{
		if (this._tabContainer == null) {
			this._tabContainer = new dijit.layout.TabContainer({
				style: "height: 100%; width: 100%;"
			}, "tab");
			this._commentsPane = new dijit.layout.ContentPane({
				title: rhpMessages.Comments,
				content: ""
			});
			this._tabContainer.addChild(this._commentsPane);
			
			this._linksPane = new dijit.layout.ContentPane({
				title: rhpMessages.Links,
				content: ""
			});
			this._tabContainer.addChild(this._linksPane);
			
			this._projectAreaPane = new dijit.layout.ContentPane({
				title: rhpMessages.Connections,
				content: ""
			});
			this._tabContainer.addChild(this._projectAreaPane);
			
			this._tabContainer.startup();
			this._tabContainer.resize();
			dojo.connect(this._tabContainer,"selectChild", this, this._onTabSelected);
		}
	},
	
	
	
	initTab: function(tab)
	{
		var tab = (tab != null)? tab : this.getFragment("tab");
		if (tab == 1)
			this._tabContainer.selectChild(this._linksPane);
		else if (tab == 2)
			this._tabContainer.selectChild(this._projectAreaPane);
		else //if (tab == 0)
			this._tabContainer.selectChild(this._commentsPane);

	},
	_onTabSelected: function(child)
	{
		this._selectedTab = child;
		if (child == this._commentsPane) {
			this.createCommentingWidget();
			this.updateFragment({tab:0});
		}
		else if (child == this._linksPane) {
			this.createLinkWidget();
			this.updateFragment({tab:1});
		}
		if (child == this._projectAreaPane) {
			this.createConnectionWidget();
			this.updateFragment({tab:2});
		}
		
	},
	
	createCommentingWidget: function()
	{
		if (this._selectedTab != this._commentsPane)
			return;
		if (this._resource == null || this.commentingWidget != null)
			return;
		this.commentingWidget = new com.ibm.rational.carter.ide.client.comment.RhpCommentingWidget({
				resourceInfo: this._resource,
				userInfo: this._user,
				clmWidget: this,
			});
	
			this.commentingWidget.startup();
			this.commentingWidget.refresh();
			this._commentsPane.domNode.appendChild(this.commentingWidget.domNode);
	},
	
	removeCommentingWidget: function()
	{
		if (this.commentingWidget != null)
		{
			this.commentingWidget.destroy();
			this.commentingWidget = null;
		}
		// clear whatever was previously displayed && display new widget
		if (this._commentsPane != null && this._commentsPane.domNode != null) {
			while (this._commentsPane.domNode.hasChildNodes()) {
				this._commentsPane.domNode.removeChild(this._commentsPane.domNode.firstChild);
			}
		}
	},
	
	createLinkWidget: function()
	{
		if (this._selectedTab != this._linksPane)
			return;
		if (this._resource == null || this.linkWidget != null)
			return;
		this.linkWidget = new com.ibm.rational.carter.ide.client.links.RhpLinks(
			{	
				resourceInfo: this._resource,
				clmWidget: this,
			}
		);
		this.linkWidget.startup();
	
		this._linksPane.domNode.appendChild(this.linkWidget.domNode);
	},

	removeLinkWidget: function()
	{
		if (this.linkWidget != null)
		{
			this.linkWidget.destroy();
			this.linkWidget = null;
		}
		if (this._linksPane != null && this._linksPane.domNode != null) {
			// clear whatever was previously displayed && display new widget
			while (this._linksPane.domNode.hasChildNodes()) {
				this._linksPane.domNode.removeChild(this._linksPane.domNode.firstChild);
			}
		}
	},
	
	getFragment: function(attr) {
		var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		return fragment[attr];
	},


	doSave: function(event) {
		if (this.commentingWidget != null) {
			var taskMonitor = new rmps.core.TaskMonitor("Saving comments");
			taskMonitor.setCanComplete(false);
			this.commentingWidget.doSave(taskMonitor);
			taskMonitor.setCanComplete(true);
		}
		if (this.linkWidget != null) {
			taskMonitor = new rmps.core.TaskMonitor("Saving links");
			taskMonitor.setCanComplete(false);
			this.linkWidget.doSave(taskMonitor);
			taskMonitor.setCanComplete(true);
		}
		if (this.subscriptionButtonController != null) {
			taskMonitor = new rmps.core.TaskMonitor("Saving Subscription");
			taskMonitor.setCanComplete(false);
			this.subscriptionButtonController.doSave(taskMonitor);
			taskMonitor.setCanComplete(true);
		}
	},
	
	isDirty: function() {
		for (var groupId in this._dirtyGroups) {
			if (this._dirtyGroups[groupId].length > 0) {
				return true;
			}
		}
		return false;
	},
	
	addDirty: function(/*String|Object*/key, /*String?*/groupId) {
		var isDirty = this.isDirty();
		
		groupId = groupId || DEFAULT;
		
		var group = this._dirtyGroups[groupId];
		if (!group) {
			group = [];
			this._dirtyGroups[groupId] = group;
		} else {
			for (var i = 0, len = group.length; i < len; ++i) {
				if (group[i] == key) {
					return;
				}
			}
		}
		group.push(key);
		
		if (!isDirty) {
			this.dirtyStateChanged(true);
		}
	},
	
	removeDirty: function(/*String|Object?*/key, /*String?*/groupId) {
		// if key == null, delete the entire group
		
		if (!this.isDirty()) {
			return;
		}
		
		groupId = groupId || DEFAULT;
		
		var group = this._dirtyGroups[groupId];
		if (!group) {
			return;
		}
		
		if (key) {
			for (var i = 0, len = group.length; i < len; ++i) {
				var groupStr = dojo.objectToQuery(group[i]);
				var keyStr = dojo.objectToQuery(key);
				
				if (groupStr == keyStr) {
					group.splice(i, 1);
					break;
				}
			}
		}
		
		if (!key || group.length == 0) {
			delete this._dirtyGroups[groupId];
		}
		
		if (!this.isDirty()) {
			this.dirtyStateChanged(false);
		}
	},
	
	_clearDirty: function() {
		if (this.isDirty()) {
			this._dirtyGroups = {};
			this.dirtyStateChanged(false);
		}
	},
	
	dirtyStateChanged: function(isDirty) {
		// listeners should connect to this method
		if (this.saveButton) {
			this.saveButton.setEnabled(isDirty);//To Do: && !this.isReadOnly);
		}
		RhpCommunicator.setDirtyState(isDirty);
			
		if (this._dirtyIndicator) {
			if (isDirty) {
				this._dirtyIndicator.style.display = "";
			} else {
				this._dirtyIndicator.style.display = "none";
			}
		}
	},
	
	_confirmRefresh: function() {
		if (!this.isDirty() || confirm(messages.confirmRefresh)) {
			this._onRefresh();
		}
	},
	
	_onRefresh: function(event) {

		if (this.commentingWidget != null)
			this.commentingWidget.refresh();

		//because the linkWidget hasn't an update function we'll just recreate it.
		this.removeLinkWidget();
		this.createLinkWidget();

	},
	
	
	save: function() {
		if (this.isReadOnly || !this.isDirty()) {
			return;
		}
		
		this.saveButton.setEnabled(false);
		
		this.showMessage({
			type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
			summary: messages.validating
		});
		
		var errors = [];
		this.validate(errors);
		
		if (errors.length > 0) {
			this._processSaveErrors(errors);
		} else {
			this._doSave();
		}
	},
	
	_doSave: function() {
		this.showMessage({
			type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
			summary: messages.saving
		});
		
		var taskMonitor = new rmps.core.TaskMonitor(messages.saving);
		taskMonitor.setCanComplete(false);
		this.doSave(taskMonitor);
		
		var handle = this.connect(taskMonitor, "onComplete", function(errors) {
			this.disconnect(handle);
			if (errors) {
				this._handleSaveErrors(errors);
			} else {
				// clear dirty state
				this._clearDirty();
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.OK,
					summary: messages.save_success,
					closable: true
				});
			}
		});
		
		taskMonitor.setCanComplete(true);
	},
	
	_processSaveErrors: function(errors) {
		var processing = false;
		
		dojo.forEach(errors, function(d) {
			if (d instanceof dojo.Deferred && !d.__processed) {
				d.__processed = processing = true;
				d.addCallback(this, function() {
					errors.splice(dojo.indexOf(errors, d), 1);
					this._processSaveErrors(errors);
				});
				d.addErrback(this, function(error) {
					errors.splice(dojo.indexOf(errors, d), 1, error ? error : undefined);
					this._processSaveErrors(errors);
				});
			}
		}, this);
		
		if (!processing) {
			if (errors.length > 0) {
				this._handleSaveErrors(errors);
			} else {
				this._doSave();
			}
		}
	},
	
	validate: function(/*Array*/errors) {

		if (this.commentingWidget != null) {
			this.commentingWidget.validate(errors);
		}
//		if (this.linkWidget != null) {
	//		this.linkWidget.validate(errors);		
		//}
	},

	_handleSaveErrors: function(errors) {
		var details = [];
		
		for (var i = 0; i < errors.length; ++i) {
			var msg =  (errors[i] instanceof Error ? errors[i].message : errors[i]);
			details.push({message: dojox.html.entities.encode(msg)});
		}
		
		this.saveButton.setEnabled(true);
		
		this.showMessage({
			type: jazz.ui.MessageBox.STATUS_TYPES.ERROR,
			summary: details.splice(0, 1)[0].message,
			details: details.length > 0 ? details : null,
			closable: true
		});
	},
	
	showLoading: function() {
		this.showMessage({
			type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
			summary: commonMessages.loading
		});
	},
	
	showMessage: function(args, closeDelay) {
		if (this.messageBox == null)
			return;
		this._resetMessageCloseDelay();
		
		if (closeDelay == null) {
			delete this.messageBox.__closeDelay;
		} else {
			this.messageBox.__closeDelay =
					parseInt(closeDelay) === closeDelay && closeDelay > 0 ? closeDelay : this.defaultMessageCloseDelay;
		}
				
		if (this.messageBox.__closeTimeout) {
			clearTimeout(this.messageBox.__closeTimeout);
			delete this.messageBox.__closeTimeout;
		}
		this.messageBox.showMessage(args);
		
		dojo.fadeIn({
				node: this.messageBox.domNode,
				beforeBegin: dojo.hitch(this, function() {
					dojo._setOpacity(this.messageBox.domNode, 0);
				})
			}).play();
		
		//this.resize(this._lastSize);
		
		this._startMessageCloseDelay();
	},
	
	_startMessageCloseDelay: function() {
		if (this.messageBox.__closeDelay) {
			this.messageBox.__closeTimeout = setTimeout(dojo.hitch(this, this.hideMessage),
				this.messageBox.__closeDelay);
		}
	},
	
	_resetMessageCloseDelay: function() {
		if (this.messageBox.__closeTimeout) {
			clearTimeout(this.messageBox.__closeTimeout);
		}
	},
	
	hideMessage: function() {
		if (this.messageBox == null)
			return;
		
		delete this.messageBox.__closeDelay;
		delete this.messageBox.__closeTimeout;
		dojo.fadeOut({
				node: this.messageBox.domNode,
				onEnd: dojo.hitch(this, function() {
					this.messageBox.hideMessage();
				})
			}).play();
	},
	
	hideMessageArea: function() {
		this.hideMessage();
	},
	
	_hideMessage: function() {
		//this.resize(this._lastSize);
	},
	
	/*setWindowLocation: function(location) {
		//window.location = location;
	},*/
	alertUser: function(msg) {
		//alert(msg);
	},
	
	
});
