/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.comment.RhpCommentingWidget");


var com_imb_rhp_svg = "";
function getSVG()
{
	return com_imb_rhp_svg;
}
function setSVG(svg)
{
	com_imb_rhp_svg = svg;
	//alertUser(com_imb_rhp_svg);
}



dojo.require("rmps.ui.commenting.CommentingWidget");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

dojo.declare("com.ibm.rational.carter.ide.client.comment.RhpCommentingWidget", 
					rmps.ui.commenting.CommentingWidget, {
	clmWidget: null,
	
	_connectHandle: null,
	
	constructor: function(view) {
		
	},

	postCreate: function(){
		
		this.inherited(arguments);
		this._connectHandle = dojo.connect(this.clmWidget,"onResourceChange", this, this.onResourceChange);
		
	},
	
	destroy: function() {
		if (this._connectHandle != null)
		{
			dojo.disconnect(this._connectHandle);
			this._connectHandle = null;
		}

		this.inherited(arguments);
	},
	
	onResourceChange: function() {
		
		this.resourceInfo = this.clmWidget._resource;
		this.userInfo = this.clmWidget._user;
		this.refresh();
		
	},
	//copied from base class
	refresh: function() {
		if (!this.isDirty()){//} || confirm(messages.confirmRefresh)) {
			if (this._editingComment) {
				delete this._editingComment;
				this.onCancelEditingComment(this._editingComment);
				this._hideCommentForm();
			}
			this._updateTitleBar(null, messages.state_loading);
			this._isLoading = true;
			if (this._securityDeferred) {
				this._securityDeferred.addCallback(this, function() {
					this._controller.getComments();
				});
			} else {
				this._controller.getComments();
			}
		}
	},

	onSelectionChanged: function(selection, previousSelection, newSelected, deselected) {
				
		var param = null;
		var svg = "";
		if (newSelected.length > 0)
		{
			//set SVG Markup of new selected comment
			var body = newSelected[0].getBody(rmps.core.commenting.BodyType.SKETCH.value);
			if (body != null) {
				svg = body.contents;
				setSVG(svg);
				var uri = newSelected[0].uri;
				var li = uri.lastIndexOf("/");
				if (li != -1)
					param = uri.substring(li+1,uri.length);
			}
			else
				setSVG(svg); //reset the svg markup
		}
		RhpCommunicator.notifyRhapsody({
					cmd: "selectionchange",
					params:(param!=null)?[param]:[],
				});
	},
	
	onStartCreateComment: function(comment) {
		this._addDirtyComment(comment);
		this.subscribe(comment);
		RhpCommunicator.notifyRhapsody({
					cmd: "startcreatecomment",
				});
	},
	onCancelEditingComment: function(comment) {
		
		this._removeDirtyComment(comment);
		this.unsubscribe(comment);
		RhpCommunicator.notifyRhapsody({
					cmd: "cancelcreatecomment",
				});

	},
	onStartEditComment: function(comment) {
		
		this._addDirtyComment(comment);

		var cmd = "starteditcomment";
		if (comment.getBody(rmps.core.commenting.BodyType.SKETCH.value) == null)
			cmd = "startcreatecomment";

		setSVG("");
		RhpCommunicator.notifyRhapsody({
					cmd: cmd,
				});

		//this.clmWidget.setWindowLocation(location);
	},
	onEndEditingComment: function(comment) {
		
		//tell rhapsody to set svg according to drawing
		var svg = "";
		setSVG(svg);
		RhpCommunicator.notifyRhapsody({
					cmd: "endeditingcomment",
				});

		
		svg = getSVG();
		//var svg2 = svg;
		//svg2 = svg2.replace(/^(\s*?\n)*/, '').replace(/\s\s*$/, '');
		if (svg != "") {
			var body;
			comment.addBody({
				type: rmps.core.commenting.BodyType.SKETCH.value,
				contents: svg //.replace(/^(\s*?\n)*/, '').replace(/\s\s*$/, '')
			});
		}
	},
	
	onCommentCreated: function(comment) {
		this._removeDirtyComment(comment);
	},
	onCommentUpdated: function(comment) {
		this._removeDirtyComment(comment);
	},
	
	onMarkCommentToDelete: function(comment) {
		this._addDirtyComment(comment);
	},
	
	onUnmarkCommentToDelete: function(comment) {
		this._removeDirtyComment(comment);
	},
	onCommentDeleted: function(comment) {
		this._removeDirtyComment(comment);
	},
	onError: function(error) {
		//To Do: output error
		//this.showMessage({errorObject: error, closable: true});
	},
		
	_addDirtyComment: function(comment) {
		this.clmWidget.addDirty(comment);
	},
	_removeDirtyComment: function(comment) {
		this.clmWidget.removeDirty(comment);
	},
	
});