/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo");
//communication with Rhapsody regarding the connections
var com_imb_rhp_connections = "";
	
function getConnections()
{
	return com_imb_rhp_connections;
}
function setConnections(connections)
{
	com_imb_rhp_connections = connections;
}

var com_imb_rhp_connectionCookies = null;
function getConnectionCookies()
{
	return com_imb_rhp_connectionCookies;
}
function setConnectionCookies(cookies)
{
	com_imb_rhp_connectionCookies = cookies;
}

var com_imb_rhp_connectionCookiesErrorMsg = null;
function getErrorMsgCookies()
{
	return com_imb_rhp_connectionCookiesErrorMsg;
}
function setErrorMsgCookies(errMsg)
{
	com_imb_rhp_connectionCookiesErrorMsg = errMsg;
}



//(function() {
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;


com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo = {

_connections: null,	

getConnectionsArray: function()
{
	this.refreshConnectionsFromRhapsody();
	return this._connections;
},

/*setConnectionCookies: function()
{
	window.location = "connection:$setConnectionCookies" + RhpCommunicator._separator + this.getCurrentServerUrl();
	var cookiesStr = getConnectionCookies();
	if (cookiesStr != "" && cookiesStr != null)
	{
		if (cookiesStr.indexOf("failed") != -1) {
			return false;
		}
		else {
			cookies = cookiesStr.split(RhpCommunicator._separator);
			dojo.forEach(cookies, function(cookie){
			
			}, this);
			return true;
		}
	}
	return false;
	
},*/



refreshConnectionsFromRhapsody: function() {
	
	RhpCommunicator.notifyRhapsody({
			cmd: "setConnections",
	});

	//window.location = "connection:$setConnections";
	
	
	this._connections = [];
	var cons = [];
	var connections = getConnections();
	if (connections != null)
		cons = connections.split(RhpCommunicator._separator);
	dojo.forEach(cons, function(c) {
		var co = dojo.queryToObject(c);
		if (co != null)
			this._connections.push(co);
		}, this);
},

	getCurrentConnection: function(connections){
	
		var locationLC = new String(window.location);
		locationLC = locationLC.toLowerCase();
		var currentConnection = "";
		
		dojo.forEach(connections,function(conn) {
			var optLC = new String(conn.url);
			if (locationLC.indexOf(optLC.toLowerCase())!=-1)
				currentConnection = conn;
		},this);
		return currentConnection;			
	},
	
	getCurrentServerUrl: function()
	{
		var locationLC = new String(window.location);
		var loc = locationLC.indexOf("/rmps");
		var serverUrl = locationLC.substring(0,loc+5);
		return serverUrl;
		
	}


/*onSelectChange: function()
{
	var select = document.getElementById("serverSelect");
	if (select.selectedIndex != -1 && select.options[select.selectedIndex].value=="new")
		this.initAddNewConnection();
	
	
},

initAddNewConnection: function()
{
	//get container
	var selectContainer = this._container;//document.getElementById("serverSelectContainer");
	//clear previous elements
	while(selectContainer.hasChildNodes()){
            selectContainer.removeChild(selectContainer.firstChild);
	}
	
	var label = document.createElement("b");
	label.appendChild(document.createTextNode("New Server URL: "));
	selectContainer.appendChild(label);
	
	var input = document.createElement("input");
	input.type = "text";
	input.value="https://<server name>:<port number>/rmps";
	input.size="50";
	input.id = "newConnectionURL";
	selectContainer.appendChild(input);

	var save = document.createElement("button");
	//save.type="button";
	save.value = "Save";
	save.textContent = "Save";
	save.style.fontSize = "12px";
	dojo.connect(save,"onclick", this, this.selectConnection);
	//save.onclick=this.selectConnection;
	selectContainer.appendChild(save);
	
	var cancel = document.createElement("button");
	cancel.value = "Cancel";
	cancel.textContent = "Cancel";
	cancel.style.fontSize = "12px";
	dojo.connect(cancel,"onclick", this, this.initConnectionsSelector);
	//cancel.onclick = this.initConnectionsSelector;
	selectContainer.appendChild(cancel);
},

selectConnection: function()
{
	var connectionUrl = null;
	var select = document.getElementById("serverSelect");
	if (select != null && select.selectedIndex != -1 && select.options[select.selectedIndex].value!="new")
		connectionUrl = select.options[select.selectedIndex].value;
	
	var input = document.getElementById("newConnectionURL");
	if (input != null)
		connectionUrl = input.value;
	if (connectionUrl != null)
	{
		//window.location = "connection:$selectConnection&" + connectionUrl;
	}
},


createConnectionSelector: function(container){
	this._container = container;
	this.initConnectionsSelector();
},
initConnectionsSelector: function()
{

	if (this._container == null)
		return;
	//get container
	this.refreshConnectionsFromRhapsody();
	var selectContainer = this._container;//document.getElementById("serverSelectContainer");
	//clear previous elements
	while(selectContainer.hasChildNodes()){
		selectContainer.removeChild(selectContainer.firstChild);
	}
	
	var label = document.createElement("b");
	label.appendChild(document.createTextNode("Server URL: "));
	selectContainer.appendChild(label);
	
	//create the select dropdown button
	var select = document.createElement("select");
	select.id = ("serverSelect");
	dojo.connect(select,"onchange", this, this.onSelectChange);
	//select.onchange = this.onSelectChange;
	
	selectContainer.appendChild(select);
	
	//add connection option to the select dropdown list
	var cons = this.getConnectionsArray();
	if (cons == null)
		return;
	var locationLC = new String(window.location);
	locationLC = locationLC.toLowerCase();
	for (var i = 0; i < cons.length; i++)
	{
		var option = document.createElement("option");
       	option.appendChild(document.createTextNode(cons[i]));
		option.setAttribute("value",  cons[i]);
		var optLC = new String(cons[i]);
		option.selected = (locationLC.indexOf(optLC.toLowerCase())!=-1);
       	select.appendChild(option);
	}
	//add addNew Option
	var option = document.createElement("option");
    option.appendChild(document.createTextNode("<add new>"));
	option.setAttribute("value", "new");
	option.selected = (cons.length == 0);
    select.appendChild(option);
	
	var button = document.createElement("button");
	button.value = "Select";
	button.textContent = "Select";
	//button.style.fontSize = "12px";
	//button.style.height = "24px";
	//button.style.width = "70px";
	dojo.connect(button,"onclick", this, this.selectConnection);
	//button.onclick=this.selectConnection;
	//button.type="button";
	selectContainer.appendChild(button);
	
}*/

		
	}//end of class
