/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.connection.connectionWidget");


/*######################################### */
// declare dependencies on other Dojo modules
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("rmps.ui.SimpleButton");

dojo.require("com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");

var ConnectionInfo = com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo;
var ProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");


// declare and implement the widget "class"
dojo.declare("com.ibm.rational.carter.ide.client.connection.connectionWidget", [ dijit._Widget, dijit._Templated ], {

	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),    
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "connection/templates/connectionWidget.html"),
	_clmWidget: null,
	_currentConnection: null, 	
	
	postCreate: function() {
		        
		this.inherited(arguments);
		this.initConnections();
		this.initProjectAreas();
		
    },
	
	onResourceChange: function() {
		//this.initProjectAreas();
	},
	
	destroy: function() {
		if (this.projectSelector != null && this.projectSelector.destroy != null )
			this.projectSelector.destroy();
		if (this.connectionSelector != null && this.connectionSelector.destroy != null )
			this.connectionSelector.destroy();

		this.inherited(arguments);
	},

	initProjectAreas: function() {
		
		var projects = ProjectAreaInfo.getProjectAreas();
		var projOptions = this.createProjectsOptions(projects);
		var currentProj = (this._clmWidget!= null)? this._clmWidget._projectArea: null;
		projOptionsJSon = {
			identifier: "value",
			label: "name",
			items: projOptions,
		}
		
		//if (this.projectSelector != null && this.projectSelector.destroyRecursive)
			
		this.projectSelector = new dijit.form.ComboBox({
			store: new dojo.data.ItemFileReadStore({
                data: projOptionsJSon
            }),
            autoComplete: true,
            //style: "width: 300px;",
            id: "projectSelector",
			value: currentProj!=null?currentProj.name:null,
        }, this.projectSelector);
		dojo.connect(this.projectSelector,'onChange',this,this._localOnProjectChange);


	},
	_localOnProjectChange: function(proj)
	{
		this._onSelectProject(proj);
	},
	_onSelectProject: function(projectName)
	{
		var y = 15;
	},
	
	initConnections: function() {
	
		//remove old options
		//while (this.connectionSelector.hasChildNodes()) {
			//this.connectionSelector.removeChild(this.connectionSelector.firstChild);
		//}
		//this.connectionSelector = new dijit.form.FilteringSelect(this.connectionContainer);
		var cons = ConnectionInfo.getConnectionsArray();
		var connOptions = this.createConnectionOptions(cons);
		this._currentConnection = ConnectionInfo.getCurrentConnection(cons);
		connOptionsJSon = {

			identifier: "value",
			label: "name",
			items: connOptions,
		}
		

		this.connectionSelector = new dijit.form.ComboBox({
			store: new dojo.data.ItemFileReadStore({
                data: connOptionsJSon
            }),
            autoComplete: true,
            //style: "width: 300px;",
            id: "connectionSelector",
			value: this._currentConnection.url,
        }, this.connectionSelector);
		
		dojo.connect(this.connectionSelector,'onChange',this,this._localOnConnectionChange);
		
		var button = new rmps.ui.SimpleButton({
					label: this.rhpMessages.Select,
					onClick: dojo.hitch(this, this._onSelectConnection)
				});
		this.connectionContainer.appendChild(button.domNode);
		
	},
	
	_localOnConnectionChange: function(conn) {
//		if (this._currentConnection != null && conn == this._currentConnection.url)
//			this._usernameContainer.style.visibility = "visible";
//		else
//			this._usernameContainer.style.visibility = "hidden";
	},
	
	_onSelectConnection: function()
	{
		var connection = null;
		if (this.connectionSelector != null)
			connection = this.connectionSelector.attr('item');
		if (connection!=null)
			connection = connection.value[0];
		else
		{
			connection = "url=" + this.connectionSelector.attr('value')+"&username=&password=";
		}
		if (connection != null)
		{
			var conn = dojo.queryToObject(connection);
			
			RhpCommunicator.notifyRhapsody({
					cmd: "selectConnection",
					params: [((conn.url!=null)?conn.url:""),
							((conn.username!=null)?conn.username:""),
							((conn.password!=null)?conn.password:"")]
				});
			/*if (this._clmWidget)
				//this._clmWidget.setWindowLocation("connection:$selectConnection" 
					+ "&" + ((conn.url!=null)?conn.url:"")
					+ "&" + ((conn.username!=null)?conn.username:"")
					+ "&" + ((conn.password!=null)?conn.password:"")
					);*/
		}
	},

	createConnectionOptions: function(connections){
			var connectionsOptions = [];
			dojo.forEach(connections,function(conn) {
				var connectionOption = {name:conn.url, 
										value:dojo.objectToQuery(conn)};
				//var connectionOption = new Option(conn, conn);
				connectionsOptions.push(connectionOption);
			},this);
			return connectionsOptions;			
		},
	createProjectsOptions: function(projects){
			var projectsOptions = [];
			dojo.forEach(projects,function(proj) {
				var projectsOption = {name:proj.name, 
										value:proj.itemId};
				projectsOptions.push(projectsOption);
			},this);
			return projectsOptions;			
		},	
		
	    
});