/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");

var com_ibm_debugging = false;
var com_imb_rhp_loggedIn = true;
if (dojo.isIE ) 
	com_imb_rhp_loggedIn = false || com_ibm_debugging;
else
	com_imb_rhp_loggedIn = true;
function getIsRhpLoggedIn(status)
{
	return com_imb_rhp_loggedIn;
}
function setIsRhpLoggedIn(status)
{
	if (status == "ok")
		com_imb_rhp_loggedIn = true;
}

var com_ibm_rhp_dirtyState = false;
function getIsDirty()
{
	return (com_ibm_rhp_dirtyState)?"true":"false";
}



dojo.require("rmps.core.RootServices");


	
com.ibm.rational.carter.ide.client.internal.RhpCommunicator = {
	
	_separator: "#rhpSep#",
	_protocol: "https://",
	_cmdSign: "$",
	
	notifyRhapsody: function(notification){
		if (notification != null)
		{
			var location = this._protocol;
			location += this._cmdSign + notification.cmd;
			if (notification.params) {
				
				for (var i = 0; i < notification.params.length; i++){
					location += this._separator + notification.params[i];
				}
			}
			//alert("notifying rhapsody:" + location)
			this.setWindowLocation(location);
		}
	},	
	
	login: function() {
		var redirectPage = window.location;
		
		var processProxy = rmps.core.RootServices.getUri(rmps.core.Namespaces.FP, "processProxy");
//		var jts_oauthDomain = new String (rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_1_0, "manageProjectAreas"));
	//	var loc = jts_oauthDomain.indexOf("jts/process/");
//		jts_oauthDomain = jts_oauthDomain.substring(0,loc+12);
//		jts_oauthDomain += "project-areas"
		var jts_oauthDomain = rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas");			
		//var jts_oauthDomain = rmps.core.RootServices.getUri(rmps.core.Namespaces.JFS_1_0, "oauthDomain");
		var loginPage = processProxy + "?uri=" + jts_oauthDomain;
		
		this.notifyRhapsody({
			cmd:"login",
			params:[redirectPage,loginPage]
		});
		
		return getIsRhpLoggedIn();
	},
	
	getCurrentServerUrl: function()
	{
		var locationLC = new String(window.location);
		var loc = locationLC.indexOf("/dm");
		var serverUrl = locationLC.substring(0,loc+3);
		return serverUrl;
		
	},

	setWindowLocation: function(location) {
		if (dojo.isIE && !com_ibm_debugging)
			window.location = location;
	},
	
	setDirtyState: function(value) {
		com_ibm_rhp_dirtyState = value;
	}
}
