/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.links.RhpLinks");
dojo.require("rmps.app.ui.internal.editors.views.Links");
dojo.require("rmps.app.ui.internal.editors.views.link.LinkClient");

var LinkClient= rmps.app.ui.internal.editors.views.link.LinkClient;


dojo.declare("com.ibm.rational.carter.ide.client.links.RhpLinks", [rmps.app.ui.internal.editors.views.Links], {
	
	clmWidget: null,
	addDirtyNotifier: function(row){
        	this.clmWidget.addDirty(row);
        },
        
    removeDirtyNotifier: function(row){
        	this.clmWidget.removeDirty(row);
        },
	_deleteLinkFailed: function()
	{
		
	},
	
	postCreate: function(){
		
		this.inherited(arguments);
		
	},
	

	doSave: function(taskMonitor, _dirty){
        	
        	try{
        		var linksToBeSaved = this._modifiedlinks[this.id]._linksToBeSaved.slice();
            
	            dojo.forEach(linksToBeSaved, function(row){
	                var link= this.linksSection.getDataForRow(row).data.linkData;
	                if (link) {
	                    var deferred = LinkClient.createLink(link);
	                    var task = taskMonitor.beginTask(dojo.string.substitute("Save Link", [link.resourceUri]), 1);
	                    task.handleDeferredWork(deferred, 1);
	                    deferred.addCallback(this, function(result){
	                        jazz.util.array.removeByReference(this._modifiedlinks[this.id]._linksToBeSaved, row);
	                        this.clmWidget.removeDirty(row);
	                        dojo.removeClass(row, "added-entry");
	                        dojo.removeClass(row, "edited-entry");
	                        dojo.addClass(row, "entry");
	                         var link= this.linksSection.getDataForRow(row);
	                        delete link.data.isNew;
	                    });
	                }
	            }, this);
	            
	            var linksToBeDeleted = this._modifiedlinks[this.id]._linksToBeDeleted.slice();
	            
	            dojo.forEach(linksToBeDeleted, function(link){
	                if (link) {
						var link_= this.linksSection.getDataForRow(link).data.linkData;
	                    var deferred = LinkClient.deleteLink(link_);
	                    var task = taskMonitor.beginTask(dojo.string.substitute("Delete Link", [link.resourceUri]), 1);
	                    task.handleDeferredWork(deferred, 1);
	                    deferred.addCallback(this, function(){
							jazz.util.array.removeByReference(this._modifiedlinks[this.id]._linksToBeDeleted, link);
		                    this.clmWidget.removeDirty(link);
		                    var table = this.linksSection.table;
		                    var index = dojo.indexOf(table.rows, link);
		                    table.deleteRow(dojo.indexOf(table.rows, link));
		                    index = index - 1;
		                    var prev = table.rows[index];
		                    var next = table.rows[index + 1];
		                    var prevData= prev?this.linksSection.getDataForRow(prev).data: null;
		                	var nextData= next?this.linksSection.getDataForRow(next).data:null;
		                    if (prevData.isHeader && (!next||nextData.isHeader)) {
		                        table.deleteRow(index);
		                    }                        
	                    });
	                }
	            }, this);
				
				
				var linksToBeEdited = this._modifiedlinks[this.id]._linksToBeEdited.slice();
				
				dojo.forEach(linksToBeEdited, function(row){
					var dataSet= this.linksSection.getDataForRow(row);
					var oldLink= dataSet.data.linkData;
					var newLink= dataSet.newLink;
	                var deferred = LinkClient.updateLink(oldLink,newLink);
	                var task = taskMonitor.beginTask(dojo.string.substitute("Update Link", [newLink.resourceUri]), 1);
	                task.handleDeferredWork(deferred, 1);
	                
	                deferred.addCallback(this, function(){
		                jazz.util.array.removeByReference(this._modifiedlinks[this.id]._linksToBeEdited, row);
		                this.clmWidget.removeDirty(row);
		                dojo.removeClass(row, "added-entry");
	                    dojo.removeClass(row, "edited-entry");
	                    dojo.addClass(row, "entry");
		            	this.linksSection.finalizeLinkUpdate(dataSet);
	                });
	            }, this);
        	} catch (e) {
                console.debug("*** ERROR: " + e.message);
            }
            
        }
	});
