/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.projectAreas.ProjectAreaClient");

dojo.require("com.ibm.rational.carter.ide.client.projectAreas.ProjectArea");

dojo.require("rmps.core.xhr");
dojo.require("jazz.client.xhr");

dojo.require("dojox.xml.DomParser");

dojo.require("rmps.core.RootServices");

var PROJECT_AREAS_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas");
var JFS_PROJECT_AREAS_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas");
//rmps.core.RootServices.getUri(rmps.core.Namespaces.JFS, "projectAreas");
//var WHOAMI_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.JFS, "currentUser");
	
com.ibm.rational.carter.ide.client.projectAreas.ProjectAreaClient = {
	
	getProjectAreas: function() {
		var query;
		var args = {
			url: PROJECT_AREAS_PATH + (query ? '?' + dojo.objectToQuery(query) : ""),
			handleAs: "text",
			headers: {
				Accept: "application/rdf+xml",
				"X-ibm-rmps-internal": "true"
			},
			load: function(response, ioArgs)
			{
				var doc = dojox.xml.DomParser.parse(response);
				var projectAreas = [];
				var entries = doc.getElementsByTagName("rdf:RDF");
				for (var i = 0; i < entries.length; i++) {
					var projectArea = new com.ibm.rational.carter.ide.client.projectAreas.ProjectArea();
					projectArea.parse(entries[i]);
					projectAreas.push(projectArea);
				}
				return projectAreas;
			}
		};
		return jazz.client.xhrGet(args);
	},
	
	getProjectArea: function(projectAreaUri) {
		var args = {
			url: projectAreaUri,
			handleAs: "text",
			headers: {
				Accept: "application/rdf+xml",
				"X-ibm-rmps-internal": "true"
			},
			load: function(response, ioArgs)
			{
				var projectArea = new com.ibm.rational.carter.ide.client.projectAreas.ProjectArea();
				projectArea.parse(dojox.xml.DomParser.parse(response));
				return projectArea;
			},
			cacheKey: null
		};
		return rmps.core.xhrGet(args);
	},
	
	getProjectAreaById: function(ProjectAreaId) {
		return this.getUser(this.getUserUri(ProjectAreaId));
	},
	
	getProjectAreaUri: function(ProjectAreaId) {
		return JFS_USERS_PATH + '/' + ProjectAreaId;
	}

};

})();


