/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {


	
	dojo.provide("carter.ui.properties.form.CheckBoxInput");

	
	
	dojo.require("dijit._Templated");
	dojo.require("rmps.ui.properties.form.LabeledSection");
	
	

	dojo.declare(
			
		"carter.ui.properties.form.CheckBoxInput",
		[
			rmps.ui.properties.form.LabeledSection,
			dijit._Templated
		],
		
		{
			
			templateString:
								'<div class="carter-ui-properties-form-CheckBoxInput">'
							+		'<input'
							+				' dojoAttachPoint="inputNode"'
							+				' type="checkbox"'
							+				' value="${value}"'
							+				' name="${name}" >'
							+		'</input>'
							+		'<label'
							+				' dojoAttachPoint="labelNode"'
							+				' style="padding-left: 1ex" >'
							+		'</label>'
							+	'</div>',
			
			
				// mixin properties
			
			label:		null,
			name:		null,
			value:		null,
			readOnly:	false,
			checked:	false,
		
		
		
			postCreate: function()
			{
				var webId = this.id + "__" + this.name + "__" + this.label;
				this.inputNode.id = webId;
				this.labelNode.htmlFor = webId;
				
				this.labelNode.appendChild(
									dojo.doc.createTextNode(
												this.label ) );
				
				this.label = "";
				
				if( this.checked )
				{
					this.inputNode.checked = true;
				}
				
				if( this.readOnly )
				{
					this.inputNode.disabled = true;
				}
			}
			
			
		}
	);		// dojo.declare

	
} ) ();
