/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {


	
	
	dojo.provide( "carter.ui.properties.form.RichTextArea" );
	

	
	dojo.require( "dijit.Editor" );
	dojo.require( "dijit._Templated" );

	dojo.require( "dijit._editor.plugins.EnterKeyHandling" );
	dojo.require( "dijit._editor.plugins.TextColor" );
	dojo.require( "dijit._editor.plugins.LinkDialog" );
	dojo.require( "dijit._editor.plugins.TabIndent" );

	dojo.require( "rmps.ui.properties.form.LabeledSection" );

	
	
	dojo.declare(
		
		"carter.ui.properties.form.RichTextArea",
		[
			rmps.ui.properties.form.LabeledSection,
			dijit._Templated
		],
		
		{
			
			templateString:
								'<div class="carter-ui-properties-form-RichTextArea">'
							+		'<div'
							+				' dojoAttachPoint="containerNode" >'
							+		'</div>'
							+	'</div>',
			
			
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// mixin properties
				
			label:		null,
			name:		"",
			value:		"",
			readOnly:	false,
			rows: 		5,
			


	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			// properties
				
			height:		75,
			editor: 	null,

			
			
			
		
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			postCreate: function()
			{
				this.height = this.rows * 15;
				this.editor = this.createEditor();

				if( this.value )
				{
					this.editor.setValue( this.value );
				}

				this.containerNode.appendChild( this.editor.domNode );
				this.editor.startup();
			},



	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			createEditor: function()
			{
				return new dijit.Editor(
						{
							height:		this.height + "px",
							disabled:	this.readOnly,
							plugins:	null
						} );
			},
			
			
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			destroy: function()
			{
				if( this.editor )
				{
					this.editor.destroyRecursive();
				}
				
				this.inherited(arguments);
			},
			
		}
	); 		// dojo.declare(
	
} )();