/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {



	dojo.provide(	"carter.ui.properties.form.SelectionList"	);

	

	
	dojo.require(	"dijit._Templated"	);
	
	dojo.require( 	"rmps.ui.properties.form.LabeledSection"	);
	
	
	
	
	dojo.declare(
		
		"carter.ui.properties.form.SelectionList",
		[ 
			rmps.ui.properties.form.LabeledSection,
			dijit._Templated
		],
		
		{
			
			templateString:			'<div'
								+			' dojoAttachPoint="containerNode" >'
								+	'</div>',

							
				// mixin properties
		
			name:		null,
			readOnly:	false,

				// 		selection list is an array of objects in the form:
				//			{
				//				value:		"",
				//				label:		"",
				//				checked:	false
				//			}
			radios:		null,
			
			
			postCreate: function()
			{
				this.inherited(arguments);
				var selectionNode = dojo.doc.createElement( "select", this.domNode );
				dojo.addClass( selectionNode, "carter-ui-properties-form-SelectionList" );

				for(  var i = 0;  i < this.radios.length;  ++i  )
				{
					var radioItem = this.radios[ i ];
					var optionElement = dojo.doc.createElement( "option", { value: radioItem.value } );
					
					if( radioItem.checked )
					{
						optionElement.selected = "selected";
					}
					else if( this.readOnly )
					{
						optionElement.disabled = "disabled";
					}
				
					optionElement.appendChild( dojo.doc.createTextNode( radioItem.label ) );
					selectionNode.appendChild( optionElement );
				}
				
				if( this.readOnly )
				{
					selectionNode.readOnly = "readOnly";
				}
				
				this.containerNode.appendChild( selectionNode );
			}
			
		}
	);		// dojo.declare

	
} )();
