/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
    dojo.provide("carter.ui.publisher.ManageModels");

    dojo.require("jazz.client.xhr");
    dojo.require("carter.ui.RootServices");
    dojo.require("dojo.parser");
    dojo.require("dojox.xml.parser");
    dojo.require("carter.ui.publisher.Model");
    dojo.require("dojo.i18n");
    dojo.requireLocalization("carter.ui", "ManageModelMessages");
    var messages = dojo.i18n.getLocalization("carter.ui", "ManageModelMessages");
    
    var REQUEST_PATH = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "publish");

    carter.ui.publisher.ManageModels = {

    	deleteModel: function(modelName, projectId) {    		
    		var delRequest = REQUEST_PATH + "?" + "projectId=" + projectId + "&" + "modelName=" + modelName;
    		
    		var args = {
        			url: delRequest,
                    handleAs: "text",
                	method: "DELETE",
                    error: function(response, ioArgs){
            			alert(message.err_delModel);
            		},
                    load: function(response, ioArgs){
            			return true;
            		}        			
        		};
        		
    		return jazz.client.xhrDelete(args);
        },
        
        getStoredModels: function(projectId) {

        	var getRequest = REQUEST_PATH + "?" + "projectId=" + projectId + "&" + "reqtype=modelslist";
        	
    		var args = {
    			url: getRequest,
                handleAs: "text",
                error: function(response, ioArgs){
        			alert(message.err_getStoredModels);
        		},
                load: function(response, ioArgs){
        			var models = [];
        			if( response != null ){
        				var dom = dojox.xml.DomParser.parse(response);
        				if( dom != null){
        					var entries = dom.getElementsByTagName("Project");
        					for (var i = 0; i < entries.length; i++) {
								var model = new carter.ui.publisher.Model();
								model.name = dojox.xml.parser.textContent(entries[i]);
								models.push(model);
        					}
        				}
        			}        			
        			return models;
        		}        			
    		};
    		
        	return jazz.client.xhrGet(args);
        }        
    };

})();
