/*******************************************************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
*******************************************************************************/
(function() {
    dojo.provide("carter.ui.publisher.ManageModelsEditorInput");

    dojo.require("rmps.app.ui.internal.EditorInput");
    dojo.require("dojox.encoding.digests.MD5");

    dojo.require("rmps.core.process.SecurityClient");

    dojo.require("carter.ui.utils");

	dojo.require("dojo.i18n");
	
	dojo.requireLocalization("carter.ui", "ManageModelMessages");
	
	var messages = dojo.i18n.getLocalization("carter.ui", "ManageModelMessages");
    var ProcessConstants = carter.ui.utils.process;
    var SecurityClient = rmps.core.process.SecurityClient;

    dojo.declare("carter.ui.publisher.ManageModelsEditorInput", rmps.app.ui.internal.EditorInput, {

        projectId: null,

        operationReport: null,

        constructor: function(params) {
            this.projectId = params.projectId;
        },

        getId: function() {
            return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
        },

        isLoaded: function() {
            return this.operationReport != null;
        },

        unload: function() {
            delete this.operationReport;
        },

        load: function() {
            var deferred = SecurityClient.isActionAllowed(
			ProcessConstants.Operations.IMPORTER,
			dojo.getObject("jazz.app.currentApplication").context,
			[
				ProcessConstants.Actions.CREATE,
				ProcessConstants.Actions.MODIFY,
				ProcessConstants.Actions.DELETE,
				ProcessConstants.Actions.REQUEST_VALIDATE,
				ProcessConstants.Actions.REQUEST_NO_VALIDATE
			]);
            deferred.addCallback(this, function(report) {
                this.operationReport = report;
                return this;
            });

            return deferred;
        },

        getIconUri: function() {
            return dojo.moduleUrl("carter.ui", "graphics/icons/manageModels.gif");
        },

		getLargeIconUri: function() {
			return dojo.moduleUrl("carter.ui", "graphics/icons/manageModels.gif");
		},
		
        getName: function() {
            return messages.manageModels;
        },

        getTooltip: function() {
            return null;
        },

        getPresentationUri: function() {
            var stateQuery = dojo.objectToQuery(this.getState());
            if (stateQuery.length > 0) {
                stateQuery = "&" + stateQuery;
            }
            return carter.ui.utils.getManageModelsViewUri() + stateQuery;
        }
    });

})();
