/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
    dojo.provide("carter.ui.publisher.Publisher");

    dojo.require("jazz.client.xhr");
    dojo.require("carter.ui.RootServices");
    dojo.require("dojo.parser");
    dojo.require("dojo.io.iframe");
    dojo.require("carter.ui.utils");
    
    var PUBLISH_PATH = carter.ui.RootServices.getUri(carter.ui.Namespaces.CARTER, "publish");

    carter.ui.publisher.Publisher = {

        publishZippedModel: function(projectId) {
            		
            var postRequest = PUBLISH_PATH + "?" + "projectId=" + projectId + "&" + "modelName=multipart/form-data";
      		 
            var td = dojo.io.iframe.send({
                url: postRequest,
                form: dojo.byId("ModelUploadForm"),
                handle: function(res, ioArgs) {
                    return ioArgs.xhr.getResponseHeader(Utils.PARAM_ERRORCODE);
                },
                error: function(res, ioArgs) {
                }
            });
        },
    
        validatepublishModel: function(projectId) {
    		
            var postRequest = PUBLISH_PATH + "?" + "projectId=" + projectId + "&" + "validate=true";
      		 
    		var args = {
        			url: postRequest,
                    handleAs: "text",
                	method: "POST",
                    error: function(response, ioArgs){
            		}
        		};
        	
    		return jazz.client.xhrPost(args);
        }    
    };
    
})();