/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("com.ibm.rational.carter.ide.client.redirect.RedirectWidget");


function noError(){return false;}

/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");

/*######################################### */
// declare dependencies on other Dojo modules
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.hash");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.require("rmps.core.resource.Resource");
dojo.require("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");

//dojo.require("rmps.core.user.User");
//dojo.require("com.ibm.rational.carter.ide.client.user.RhpUserClient");

dojo.require("rmps.core.RootServices");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
 

dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.app.ui.internal.dialogs.AddCALMLinksDialog");

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
dojo.requireLocalization("rmps.app.ui.internal.editors", "BaseEditorMessages");
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

//dojo.require("com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");

dojo.require("rmps.ui.resource.ResourceIconLabel");


//var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");
//var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.editors", "BaseEditorMessages");

var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

//var UserClient = com.ibm.rational.carter.ide.client.user.RhpUserClient;
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;
var ResourceInfoClient = com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient;
//var ConnectionInfo = com.ibm.rational.carter.ide.client.connection.RhpConnectionInfo;
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

var DEFAULT = "default";

// declare and implement the widget "class"
dojo.declare("com.ibm.rational.carter.ide.client.redirect.RedirectWidget", [ dijit._Widget, dijit._Templated ], {
    templatePath: dojo.moduleUrl("com.ibm.rational.carter.ide.client", "redirect/templates/redirect.html"),
    
	// properties
//	_user:null,
	_resource:null,
	_projectArea:null,
	_resourceNameLbl:null,
	

	constructor: function() {
		window.onerror = noError;
	},

	initAfterCookiesSet: function()
	{
		var deferred = RhpProjectAreaInfo.init();
//		deferred.addCallback(this,this.initUser);
		deferred.addCallback(this,this.initResource);
		deferred.addCallback(this,this.redirectPage);
		return deferred;

	},
	
    
	postCreate: function() {
		
		//triggers the login window if needed
		if (RhpCommunicator.login() == false)
			return;

		//update resourceLabelName
		this._resourceNameLbl.innerHTML = this.getFragment("resourceName");
	
		this.initAfterCookiesSet();
        
		this.inherited(arguments);
     },


	
	
	
//	initUser: function() {
//		
//		//get userUri
//		var deferred = UserClient.whoAmI();
//		deferred.addCallback(dojo.hitch(this, function(user) {
//			this._user = user;
//		}));
//		return deferred;
//		
//	},
	
	setThisProjectArea: function (pa) {
		this._projectArea = pa;
		RhpCommunicator.notifyRhapsody({
				cmd: "projectareaselected",
				params: (this._projectArea != null)?[this._projectArea.name]:[],
			});

	},
	
	initResource: function() {
		//set project Area		
		//get the Project Id from the fragment
		var projectName = this.getFragment("projectName");
		this._projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);
		var modelName = this.getFragment("modelName");
		var resourceId = this.getFragment("resourceId");
		
		//that has this resource published
		if (this._projectArea != null)
		{
			this.setThisProjectArea(this._projectArea);
			var MODELS_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "models");
			
			var resourceUri = MODELS_PATH +
				"/" + this._projectArea.itemId +
				"/" + this._projectArea.groupId +
				"/" + modelName +
				"/" + resourceId;
			var deferred = ResourceInfoClient.getResourceInfo(resourceUri);
			deferred.addCallback(this, function(infos){
				this._resource = (infos != null)? infos[0]:null;
				});
			deferred.addErrback(this,function(err){
				this._resource = null;
			});
			return deferred;
		}
		else {
			
			var deferred = RhpProjectAreaInfo.getDefaultProjectAreas(resourceId,modelName);
			deferred.addCallback(this, function(resourceInfo) {
				var info;
				if(dojo.isArray(resourceInfo)){
					info= resourceInfo[0];
				}else{
					info= resourceInfo;
				}
				this._resource = info;
				if (this._resource != null) {
					this.setThisProjectArea(RhpProjectAreaInfo.getProjectAreaByUrl(
									this._resource.resourceContext));
				}
			});
			deferred.addErrback(this,function(err){
				
			});
			return deferred;
		}
		return null;
	},
	
	redirectPage: function() {
		//redirect to resource location
		if (this._resource != null) {
			window.location.href = this._resource.uri;
		}
		else
		{
			this._resourceNameLbl.innerHTML = this.getFragment("resourceName") + " isn't published on this server";
		}
	},
	
	
	getFragment: function(attr) {
		var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		return fragment[attr];
	},

	alertUser: function(msg) {
		//alert(msg);
	},
	
	
});
