/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

	
	
	dojo.provide( "carter.ui.relations.RelatedElements" );
	
	
	
    dojo.require( "dojo.i18n" );
    dojo.require( "dojo._base.lang" );    
	dojo.require( "net.jazz.ajax.ui.PlatformUI" );
    dojo.require( "jazz.client.xhr");
//	dojo.require( "jazz.ui.ResourceLink" );
	dojo.require( "rmps.app.core.util" );
    dojo.require( "rmps.core.Enum" );
    dojo.require( "rmps.core.error" );
    dojo.require( "rmps.core.query.BasicQueryResult" );
    dojo.require( "rmps.core.resource.ResourceInfoClient" );
    dojo.require( "rmps.app.ui.internal.editors.views.RelatedElements" );
    dojo.require( "rmps.app.core.internal.util.QueryUtil" );

    dojo.require( "carter.ui.RootServices" );

    
    
    dojo.requireLocalization( "rmps.app.ui.internal.editors.views", "RelatedElementsMessages" );
    dojo.requireLocalization( "carter.ui", "RelationsMessages" );

    
    
    var messages = dojo.i18n.getLocalization( "carter.ui", "RelationsMessages" );
    
    var messagesRelatedElements = dojo.i18n.getLocalization(
									"rmps.app.ui.internal.editors.views",
									"RelatedElementsMessages" );

	var CARTER_SEARCH_PATH = carter.ui.RootServices.getUri( carter.ui.Namespaces.CARTER, "search" );
	
	var CARTER_COLUMN_REFERENCEDIRECTION = "referenceDirection";
	var CARTER_COLUMN_REFERENCEOTHEREND = "referenceOtherEnd";
	var CARTER_COLUMN_ICONURI = "iconUri";
	
	
    
    dojo.declare(

	    	"carter.ui.relations.RelatedElements",
	    	[
				rmps.app.ui.internal.editors.views.RelatedElements,
			],
    	
    	{
	    		
		    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    		m_arrHeaders: [],
	    		
	    		
	    		
		    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
				carterQueries: new rmps.core.Enum(
						{
								ELEMENT_REFERENCED_ELEMENTS: new rmps.core.EnumLiteral(
										{	
											name:	messages.referencedElements,
											value:	'referencedElementsOfElement'
										} ),
											
								ELEMENT_REFERENCING_ELEMENTS: new rmps.core.EnumLiteral(
										{
											name:	messages.referencingElements,
											value:	'referencingElementsOfElement'
										} ),
										
								ELEMENT_REFERENCING_DIAGRAMS: new rmps.core.EnumLiteral(
										{
											name:	messages.referencingDiagrams,
											value:	'referencingDiagramsOfElement'
										} ),
								
								ELEMENT_CONTAINED_ELEMENTS: new rmps.core.EnumLiteral(
										{
											name:	messages.containedElements,
											value:	'containedElementsOfElement'
										} ),
										
								DIAGRAM_REFERENCED_ELEMENTS: new rmps.core.EnumLiteral(
										{
											name:	messages.referencedElements,
											value:	'referencedElementsOfDiagram'
										} )
						}
					),

					
					
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
			postCreate: function() {
	    		this.Queries = this.carterQueries;
				this.inherited(arguments);
			},

			
					
			//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	_addOption: function( query )
	    	{
				this.addOption( query.name, query.value );
	    	},
	
	    	
	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	createTableHeaders: function()
	    	{
    			this.m_arrHeaders = this.inherited(arguments);
	    		var nIndex;
	    		
	    		// Insert RelationType after type and remove the modified fields 
	    		
	    		for( nIndex = this.m_arrHeaders.length-1; nIndex >= 0; nIndex-- )
	    		{
	    			if( this.m_arrHeaders[nIndex].id == "type" )
	    			{
		    			this.m_arrHeaders.splice( nIndex+1, 0,
		    					
		    					this.carter_CreateTableHeader(
    		    						CARTER_COLUMN_REFERENCEDIRECTION,
    		    						{ filterParticipant: true, isOrderable: true } ),
    		    				
    		    				this.carter_CreateTableHeader(
		    		    				CARTER_COLUMN_REFERENCEOTHEREND,
		    		    				{ filterParticipant: true, isOrderable: true } )
		    		    );
	    			}
	    			else if(	this.m_arrHeaders[nIndex].id == "longName"
							||	this.m_arrHeaders[nIndex].id == "modified"
    						||	this.m_arrHeaders[nIndex].id == "modifiedBy" ) 
	    			{
		    			this.m_arrHeaders.splice( nIndex, 1 );
	    			}
	    		}
	    		
	    		this.m_arrHeaders.unshift( this.createTableHeader( CARTER_COLUMN_ICONURI, {} ) );
	    		return this.m_arrHeaders;
	    	},

	    	
	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	carter_CreateTableHeader: function( id, args )
	    	{
	    		var header = { isOrderable: false };
	    		dojo.mixin( header, args );
	    		header.id = id;
	    		header.label = messages[ id ];
	    		return header;
	    	},
	    	
	    	
	    	
	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	_createCellResourceLink: function( cell, name, resourceUri )
	    	{
				//	var link = new jazz.ui.ResourceLink(
				//		{
				//			uri: 				resourceUri,
				//			presentationUri:	rmps.app.core.util.getViewResourceUri( resourceUri ),
				//			label:				name,
				//		}		
				//	);
				//				
				//	cell.appendChild( link.domNode );
				
				var hrefElement = dojo.doc.createElement( "a" );
				hrefElement.href = rmps.app.core.util.getViewResourceUri( resourceUri );
				hrefElement.appendChild( dojo.doc.createTextNode( name ) );
				cell.appendChild( hrefElement );
	    	},

	    	
	    	
	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	createColumnObject: function( rowObj, columnId, resourceUri, presentationUri )
	    	{
	    		var result;
	    		
	    		if( columnId == CARTER_COLUMN_REFERENCEDIRECTION )
	    		{
	    			result =	{ 
	    							data: rowObj["rdf:Description"][0]["carter:referenceDirection"][0].value
	    						};
	    		}
	    		else if( columnId == CARTER_COLUMN_REFERENCEOTHEREND )
	    		{
	    			var refName = rowObj["rdf:Description"][0]["carter:referenceOtherEndName"][0].value;
	    			var refUri = rowObj["rdf:Description"][0]["carter:referenceOtherEndUri"][0].value;

	    			result =	{
									data: refName
								};

	    			if( refUri && refName )
	    			{
		    			result.init = dojo.hitch( this,
	    								
	    								function(rowConfig, tableRow, rowIdx, columnConfig, cell, colIdx)
	    								{
	    									this._createCellResourceLink( cell, refName, refUri );
	    								}
    								);
	    			}
	    		}
	    		else if( columnId == CARTER_COLUMN_ICONURI )
	    		{
	    			result = {};
	    			var iconSrc = null;

	    			if( rowObj.__carterIcon )
	    			{
	    				iconSrc = rowObj.__carterIcon;
	    			}
	    			else
	    			{
		    			result.deferred = new dojo.Deferred();
						
		    			result.deferred.addCallback( this,
		    					
								function(info)
								{
	    							iconSrc = info.iconUri;
	    							rowObj.__carterIcon = iconSrc;
	    							delete result.deferred;
								}
						);
	    			}
		    		
	    			result.init = dojo.hitch( this,
	    								
	    								function(rowConfig, tableRow, rowIdx, columnConfig, cell, colIdx)
	    								{
			    							if( iconSrc )
			    							{
			    								var icon = document.createElement( "img" );
			    								icon.className = "actions"; 
			    								icon.src = iconSrc;
												cell.appendChild( icon );
												cell.style.width = ( icon.style.width * 26 ) + "px";
												cell.style.padding = 0;
			    							}
	    								}
    								);
	    			
	    		}
	    		else
	    		{
		    		result = this.inherited( arguments );
		    		
		    		if( columnId == "name" )
		    		{
		    			var name = result.data;
		    			result.link = false;
		    			result.init = dojo.hitch( this,
		    								
	    								function(rowConfig, tableRow, rowIdx, columnConfig, cell, colIdx)
	    								{
	    									this._createCellResourceLink( cell, name, this.getRowResourceUri( rowObj ) );
	    								}
    								);
		    		}
	    		}
	    		
	    		return result;
	    	},

	    	
	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	    	executeQuery: function( query, preserveFilter )
	    	{
	    		net.jazz.ajax.ui.PlatformUI.getWorkbench().showMessage(
	    				dojo.string.substitute( messagesRelatedElements.runningQuery, [ query.name ] ) );
	    		
	    		var deferred = this.carter_ExecuteClientQuery( query );
	    				
	    		deferred.addCallback( this,
	    			function( queryResult )
					{
						this.showResults( queryResult, preserveFilter );
					}
	    		);
	    		
	    		deferred.addBoth(
					function()
					{
						net.jazz.ajax.ui.PlatformUI.getWorkbench().hideMessageArea();
					}
				);
	    		
	    		deferred.addErrback(
					function( error )
					{
						if( ! dojo._isDocumentOk( deferred.ioArgs.xhr ) )
						{
		    				rmps.core.error.createXhrError( deferred.ioArgs ).dispatch();
		    			}
						else
		    			{
		    				rmps.core.error.createError( error ).dispatch();
		    			}
					}
				);
	    		
	    	},


	    	
	    	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    		carter_ExecuteClientQuery: function( query, result )
    		{
    			var args = {
    							url:		CARTER_SEARCH_PATH + '?' + query.toQueryString(),
    									
    							headers:	{	"Accept": "application/atom+json",
	    										"X-ibm-rmps-internal": "true"
	    									},
    									
    							handleAs:	"json",
    									
    							load:		function( response, ioArgs )
											{
												if( result && result.parse )
												{
													result.parse( response, ioArgs );
													return result;
												}
												else
												{
						    						var basicResult = new rmps.core.query.BasicQueryResult(query);
						    						basicResult.parse( response, ioArgs );
						    						return basicResult;
												}
											}
    				};
    			
    			return jazz.client.xhrGet( args );
    		},


    		
    		//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    		_showQueryResults: function(tableData, queryResult, preserveFilter)
    		{
    			dojo.forEach(
    					tableData,
    					function( tableDataRow )
		    			{
    						tableDataRow.link = null;
    						tableDataRow.resourceUri = null;
		    			},
		    			this );
    			
    			this.inherited( arguments );
    		}
    		
    		
		}
    );		// dojo.declare
    
    
    
} )();
