/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");

dojo.require("rmps.core.resource.ResourceInfoClient");
dojo.require("rmps.core.resource.ResourceInfo");

dojo.require("rmps.core.xhr");

dojo.require("rmps.core.RootServices");

var INFO_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "info");

var BASELINE_PARAM = "rmps.context";

com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient = 
						dojo.mixin(rmps.core.resource.ResourceInfoClient, {
	
	_getResourceInfos: function(resourceUris, properties) {
		var uris = resourceUris;
		if (!dojo.isArray(uris)) {
			uris = [uris];
		}
		var queryParams = {};
		var key = uris.join(',');
		if (properties) {
			properties.sort();
			queryParams.properties = properties.join(',');
			key += queryParams.properties;
		}
		
		// Baseline
		var baselineParam = "";
		var baseline = jazz.app.context.get().baseline;
		if (baseline) {
			baselineParam = '&' + BASELINE_PARAM + '=' + baseline;
		}
		
		var args = {
			url: INFO_PATH + '?' + dojo.objectToQuery(queryParams) + baselineParam,
			handleAs: "json",
			headers: {
				"Content-Type": "application/rdf+xml",
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			load: function(response, ioArgs) {
				var descriptions = response["rdf:Description"];
				var resourceInfos = [];
				
				if (descriptions) {
					for (var i = 0; i < descriptions.length; ++i) {
						var resourceInfo = new rmps.core.resource.ResourceInfo();
						resourceInfo.parseDescription(descriptions[i]);
						resourceInfos.push(resourceInfo);
					}
				}
				
				if (resourceInfos.length > 0) {
					return resourceInfos;
				}
				else
					return [null];
				//throw new Error("Resource not found " + resourceUris);
			},
			haseBody: true,
			postData: this._createInfoRequest(uris),
			cacheKey: key
		};
		return rmps.core.xhrPost(args);
	},
	
	});
})();