
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rational.carter.ide.client.reviews.ReviewTable");
dojo.require("jazz.ui.PagedTable");
dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
dojo.require("rmps.app.ui.internal.editors.views.review.model.ReviewClient");
dojo.require("rmps.viewlets.internal.reviews.SimpleReviewDetails");
dojo.require("rmps.core.RootServices");

var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;
var ReviewClient = rmps.app.ui.internal.editors.views.review.model.ReviewClient;

//var PROJECT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "projects");
//PROJECT_PATH = PROJECT_PATH.replace("projects","web/projects");

dojo.declare("com.ibm.rational.carter.ide.client.reviews.ReviewTable", 
					jazz.ui.PagedTable, {
	
	_projectArea: null,
	_user: null,
	postCreate: function(){
		this.inherited(arguments);

	},
	
	fetch: function(startIndex, count, entries, details) {
		var deferred = new dojo.Deferred();
		var projectId = this._projectArea.itemId;
		var context = this;
		this._errorMsgNode = null;
		if (!projectId) {
			//this._noProjectSpecified();
			return null;
		}
		var reviewDef = ReviewClient.getReviews(projectId, this._user.id);
		reviewDef.addCallback(function(reviews) {
			function comparator(a, b) {
				var ta = a.dueDate.getTime();
				var tb = b.dueDate.getTime();
				return ta < tb ? 1 : ta == tb ? 0 : -1;
			}
			function parseEntries(response) {
				// may be overridden by clients
				// return []
				return response;
			}
	
			function parseDetails(response) {
				// may be overridden by clients
				// return []
				return parseEntries(response);
			}
			reviews.sort(comparator);
			var dataStructure = {
				"entries": entries ? parseEntries(reviews) : null,
				"details": details ? parseDetails(reviews) : null
			};
			context.setResultCount(reviews.length)

			deferred.callback(dataStructure);
		});
		reviewDef.addErrback(function() {
			deferred.errback();
		});
		return deferred;
	},
	
	
	renderEntry: function(/* object */ entryData, /* object */ detailsData, /* boolean */ zoomed) {
		if (!zoomed) {
			var widget = this.createEntryWidget(entryData);
			//this._currentWidgets.push(widget);
			
			//this.styleEntry(widget, this._updating);
			//this._updating = false;
			
			var td = dojo.doc.createElement("td");
			td.style.padding = "0px";
			td.appendChild(widget.domNode);
			return [td];
		}
		return [];
	},

	createEntryWidget: function(data) {
		return new rmps.viewlets.internal.reviews.SimpleReviewDetails({
				revSummary: data,
				getProjectPrefix: dojo.hitch(this, this.getProjectPrefix)
			});
	},
	getProjectPrefix: function(){
//		var context= jazz.app.context.get();
//		if(context){
//			name= context.name;
//		}
//		if(name){
//
//
//			return PROJECT_PATH + "/" + name;
//		}
		if (com_ibm_debugging==true)
			return "?debug=true";
		else
			return "";
	},

	renderDetails: function(/* object */ detailsData) {
		var widget = this.createDetailsWidget(detailsData);
		//this._currentWidgets.push(widget);
		
//		this.styleEntry(widget, this._updating);
//		this._updating = false;
		
		var td = dojo.doc.createElement("td");
		td.style.padding = "7px";
		td.appendChild(widget.domNode);
		return [td];
	},

	

	
});