/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

function noError(){return true;}

(function() {
dojo.provide("com.ibm.rational.carter.ide.client.reviews.ReviewWidget");
/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");


dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojox.html");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.hash");

dojo.require("rmps.core.RootServices");

dojo.require("rmps.app.ui.ReviewEditorUtil");
dojo.require("rmps.app.ui.internal.editors.views.review.utils.ReviewUtil");
dojo.require("rmps.app.core.util");

dojo.require("rmps.core.BackendScr");

//reviews
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");
dojo.require("rmps.app.ui.internal.editors.ReviewEditor");
dojo.require("rmps.app.ui.internal.ReviewEditorInput");
dojo.require("rmps.app.ui.internal.editors.RegisterReviewEditorsInitializer");
//dojo.require("com.ibm.rational.carter.ide.client.reviews.RhpRegisterReviewEditorsInitializer");
dojo.require("com.ibm.rational.carter.ide.client.user.RhpUserClient");
var UserClient = com.ibm.rational.carter.ide.client.user.RhpUserClient;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

dojo.require("rmps.app.ui.internal.editors.views.review.model.ReviewClient");
var ReviewClient = rmps.app.ui.internal.editors.views.review.model.ReviewClient;
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");
var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient");
var ResourceInfoClient = com.ibm.rational.carter.ide.client.resource.RhpResourceInfoClient;

dojo.require("rmps.app.ui.internal.util.UrlUtil");
var UrlUtil= rmps.app.ui.internal.util.UrlUtil;

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");

dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

var rhp_review_workBench = {
	registerOnBeforeUnloadHandler: function(){
		
	},
	unregisterNavigateAwayHandler: function(){
		
	},
	showMessage: function() {
		
	},
	hideMessageArea: function() {
		
	},
	setTitle: function() {
		
	}
}
dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("rmps.ui.resource.ResourceIconLabel");

//dojo.require("rmps.viewlets.internal.reviews.ReviewsViewlet");
dojo.require("com.ibm.rational.carter.ide.client.reviews.ReviewTable");
dojo.declare("com.ibm.rational.carter.ide.client.reviews.ReviewWidget", [dijit._Widget, dijit._Templated], {
	
	"class": "root",
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "reviews/templates/ReviewWidget.html"),
	
	// private properties
	_projectArea: null,
	_user: null,
//	_resource: null,

	_connectionWidget: null,	

	_reviewTable: null,	
	_reviewEditor: null,
	_editorUtil: null,
	_editorInput: null,
	_reviewUri: null,
	reviewTableHeader:null,
//	_newReviewCreated: false,
	_toolbarContainer:null,
	newButton:null,
	_mediator:null,
	

	


	constructor: function(params){
		window.onerror = noError;
		this.mediator = new com.ibm.rational.carter.ide.client.reviews.ReviewWidget._Mediator();
		//patch to allow reviewing reviews defined on baselines.
		rmps.app.ui.internal.editors.views.review.utils.ReviewUtil.isBaselineMatches = function(review) {
			return true;
		};
    },
	
	buildRendering: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
	},
	
	postCreate: function() {
		
		//triggers the login window if needed
		if (RhpCommunicator.login() == false) {
			return;
		}

		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.initUser);
		deferred.addCallback(this,this.init);

	},
	_onClickTableHeader: function(){
		if (this.reviewTableContainer.style.display=="none")
			this.reviewTableContainer.style.display="inline";
		else
			this.reviewTableContainer.style.display="none";
	},

	createConnectionWidget: function() {
		if (this._connectionWidget == null) {
			this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget({
				_clmWidget: this,
			});
			this.connectionContainer.appendChild(this._connectionWidget.domNode);
			dojo.connect(this._connectionWidget, "_onSelectProject", this, this.initProjectAreaSelection);
		} 

	},
	initUser: function() {
		
		//get userUri
		var deferred = UserClient.whoAmI();
		deferred.addCallback(dojo.hitch(this, function(user) {
			this._user = user;
			this._user.userId = this._user.id;
		}));
		return deferred;
		
	},

	onSelectProjectArea: function(projectArea){
		this._projectArea = projectArea;
		
		RhpCommunicator.notifyRhapsody({
				cmd: "projectareaselected",
				params: (this._projectArea != null)?[this._projectArea.name]:[],
			});

		if (this._projectArea != null) {
			dojo.getObject("currentApplication", true, jazz.app).context = this._projectArea.url;
			jazz.app.context.set(this._projectArea);
			dojo.getObject("config", true, jazz.app.currentApplication).user = this._user;
			dojo.getObject("currentApplication", true, jazz.app).applicationContext = this._projectArea;
			
			dojo.getObject("net.jazz.ajax.ui.PlatformUI",true);
			net.jazz.ajax.ui.PlatformUI.getWorkbench = function(){
				return rhp_review_workBench;
			}
			jazz.client.xhrGet({
				url: rmps.core.BackendScr.get().getUriForPath([
					{namespace: rmps.core.Namespaces.JUENTRY, name: "JTSApplicationAdminLinksService"},
					{namespace: rmps.core.Namespaces.JD_1_0,name: "service"}
				]),
				headers: {
					"Accept": "application/rdf+json",
					"X-ibm-rmps-internal": "true"
				},
				handleAs: "json",
				sync: true,
				load: dojo.hitch(this, function(response) {
					this.processTemplateManagementUrl= response.processTemplateManagement.url;
//					this.projectArea= response.projectArea.url;
//					this.reportsManagementUrl= response.reportsManagement.url;
//					this.usersUrl= response.users.url;
					
					jazz.app.context.get().applicationId= UrlUtil.getParamater(this.processTemplateManagementUrl, UrlUtil.OWNNING_APPLICATION_KEY);
				})
			});
			
//			jazz.client.xhrGet({
//			url: rmps.core.RootServices.getUri(rmps.core.Namespaces.JP, "manageProjectAreas"),
//			handleAs: "xml", //$NON-NLS-1$
//			sync: true,
//			load: dojo.hitch(this, function(response) {
//				var UrlUtil= rmps.app.ui.internal.util.UrlUtil;
//				var context = jazz.app.context.get();
//				if (context && context.name) {
//					var url= response.getElementsByTagName("jp:url")[0];
//					if(url){
//						var value= url.childNodes[0].nodeValue;
//						if(value){
//							context.applicationId= UrlUtil.getParamater(value, UrlUtil.OWNNING_APPLICATION_KEY);
//							return;
//						}
//					}
//					var manageProjectArea= response.getElementsByTagName("manageProjectAreas")[0];
//					if(manageProjectArea){
//						var url= manageProjectArea.getElementsByTagName("url")[0];
//						if(url){
//							var value= url.childNodes[0].nodeValue;
//							if(value){
//									context.applicationId= UrlUtil.getParamater(value, UrlUtil.OWNNING_APPLICATION_KEY);
//								}
//							}
//						}
//					}
//			})
//		});
	
//			dojo.getObject("importer.ImportClient",true,rmps).getStatusForProject = function(){
//				var def = new dojo.Deferred();
//				def.addCallback(function(){
//					return {};
//				});
//				return def;
//			}
		}
		if (this._projectArea != null) {
			this.createViewlet();
			if (this.newButton)
				this.newButton.setEnabled(true);	
		}
		else {
			if (this.newButton)
				this.newButton.setEnabled(false);
			this.removeViewlet();
		}
	},
	
	initProjectAreaSelection: function(projectName){

		if (projectName == null)
			projectName = this.getFragment("projectName");
//		if (projectName == null)
//			projectName = "modeler";
		this._projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);
		this.onSelectProjectArea(this._projectArea);
	
	},

	closeReviewEditor: function(){
		
//		if (this._editorUtil != null) {
//			alert("clear started");
//			//var reviewEditor = this._editorUtil.getEditor(this._editorInput);
//			if (this._editorInput != null)
//			{
//				//if (this._reviewEditor)
//					//this._reviewEditor.destroy();
//				this._editorUtil.closeEditorInput(this._editorInput, true,true);
//				this._editorInput = null;
//				this._reviewEditor = null;
//				alert("clear succeeded");
//			}
//		}
	},
	destroy: function() {
		this.closeReviewEditor();
		this.inherited(arguments);
	},
	destroyRecursive: function() {
		
//		this.closeReviewEditor();
//		alert("destorying");
//		this.inherited(arguments);
//		alert("succeeded");
	},
	_onNewReview: function(){

		//Will be needed for RC2
		window.location.href = "#resourceUri=" + rmps.app.ui.ReviewEditorUtil.NEW_REVIEW_EDITOR;
		//rmps.app.ui.ReviewEditorUtil.createReview();
		
		//this._onRefreshViewlet();
	},
	
	showReviewEditor: function() {
//		}
		if (this._editorUtil == null) {
			this._editorUtil = rmps.app.ui.EditorUtil.getInstance(this._reviewUri,this.reviewEditorContainer);
			dojo.connect(this._editorUtil, "onEditorOpened", this, this._onEditorOpened);
			dojo.connect(this._editorUtil, "onEditorClosed", this, this._onEditorClosed);
			this._editorUtil.domNode = this.reviewEditorContainer;
			this._editorUtil.containerNode = this.reviewEditorContainer;
		}
		this.closeReviewEditor();
		var args = {
			resourceUri: this._reviewUri, 
			resourceInfo:this._reviewUri,
			tab:"main",
			type:"reviewDiagram",
			mediator: this.mediator
		};
		this._editorInput = new rmps.app.ui.internal.ReviewEditorInput(args);

		this._editorUtil.openEditor(this._editorInput);
		
		
	},
	_onEditorOpened: function(editor)
	{
		this._reviewEditor = this._editorUtil.getEditor(this._editorInput);
		this._fixEditor(this._reviewEditor);
		//to resize comments view.
		this._reviewEditor.accordion.resize({h:450,w:240});
		//dojo.connect(this._reviewEditor, "onTabChange", this, this._resizeReviewEditor);
		//to trigger the population of the resources tab
		this._reviewEditor.resize();
	},
	
	_resizeReviewEditor: function()
	{
		if (this._reviewEditor != null)
			this._reviewEditor.resize();
		
	},
	_fixEditor: function(editor)
	{
		editor.destroyRecursive = dojo.hitch(editor, function(){
			this.removeCommentingWidgets();
			this.inherited("destroyRecursive", arguments);
		});

		editor.destroy = dojo.hitch(editor, function(){
			this.removeCommentingWidgets();
			if(this.reviewMessageBox){
				this.reviewMessageBox.destroy();
			}
			if(this._breadCrumbs){
				this._breadCrumbs.destroy();
			}
			if(this.accordion){
				this.accordion.destroy();
			}
			if(this.selectionCommentingWidget){
				this.selectionCommentingWidget.destroy();
			}
	
			this.inherited("destroy",arguments);
			this.callBacks= null;
		});
	
		editor.removeCommentingWidgets = dojo.hitch(editor, function(){
			/*We have to remove the commenting widget from the children as it will be destroyed later by the parent class. Otherwise, there will be an extra
			 * attemp to detroy  commentingWidget in a lter call for destroyRecursive, and this will cause an error*/
			if(this.commentingWidget){
				var children= this.accordion.getChildren();
				for(var index=0 ;index< children.length; index++){
					var current= children[index];
					if(current==this.commentingWidget){
						this.accordion.removeChild(this.commentingWidget);
					}else if(current==this.selectionCommentingWidget){
						this.accordion.removeChild(this.selectionCommentingWidget);
						this.selectionCommentingWidget.destroy();
						delete this.selectionCommentingWidget;
					}
				}
			}
		});
		
	},
	_onEditorClosed: function(editor)
	{
		if (this._reviewEditor == editor)
		{
			//refresh viewlet when editor is closed
			//closing editor probably means the review is deleted
			//todo: find a better way to be noticed on deletion of review.
			var deferred = new dojo.Deferred();
			setTimeout(dojo.hitch(this, this._onRefreshViewlet),0);
			return deferred;
						
		}

	},


	
			
	getFragment: function(attr) {
		var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		return fragment[attr];
	},

	init: function() {
		
		this.initProjectAreaSelection();
		this.createConnectionWidget();
		this.createViewletToolbar();
		dojo.connect(this.reviewTableHeader, "onclick", this, this._onClickTableHeader);
		//subscribe to show in browser event.		
		 dojo.subscribe("rmps.web.app.explorer.show", this, function(resourceUri){
		 	if (resourceUri != null) {
				RhpCommunicator.notifyRhapsody({
					cmd: "ShowInExplorer",
					params:[resourceUri.uri]
				});
			}
 		});

		//subscribe on has change to catch pageSize changes
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");
		this.onHashChange();
		

		
	},
	_onRefreshViewlet: function() {
		this.removeViewlet();
		this.createViewlet();
	},
	
	removeViewlet: function()
	{
		this._reviewTable = null;
		// clear whatever was previously displayed && display new widget
		if (this.reviewTableContainer != null) {
			while (this.reviewTableContainer.hasChildNodes()) {
				this.reviewTableContainer.removeChild(this.reviewTableContainer.firstChild);
			}
		}
	},

	createViewlet: function() {
		if (this._reviewTable != null && this._reviewTable._projectArea != this._projectArea) {
			this.removeViewlet();
		}
		if (this._reviewTable == null) {
			this._reviewTable = new com.ibm.rational.carter.ide.client.reviews.ReviewTable({
				_projectArea: this._projectArea,
				_user: this._user,
				itemsPerPage: 5,
			});//
			this.reviewTableContainer.appendChild(this._reviewTable.domNode);
		}

		
	},
	createViewletToolbar: function()
	{
		if (this.toolbar != null)
			return; 

		// toolbar
		this.toolbar = new jazz.ui.SimpleToolbar();
		this.toolbar.containerNode = this.toolbar.domNode;
		
		if (dojo.isIE < 8) {
			this._toolbarContainer.insertBefore(this.toolbar.domNode, this.messageBox.domNode);
		} else {
			this._toolbarContainer.appendChild(this.toolbar.domNode);
		}
		this.addButtonsViewlet(this.toolbar);
	},

	addButtonsViewlet: function(toolbar) {
		
		this.newButton = toolbar.addWidget(new rmps.ui.SimpleButton({
					label: rhpMessages.new_review,
					onClick: dojo.hitch(this, this._onNewReview)
				}));
			this.newButton.setEnabled(this._projectArea != null);
		
		this.refreshButton = toolbar.addButton(this, this._onRefreshViewlet, {
				label: commonMessages.refresh,
				imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/refresh.gif")
			});	
	},

	onHashChange: function(hash) {
		var newHash = (hash != null)? hash : dojo.hash();
		var newHashObj = dojo.queryToObject(newHash);
		
		if (newHashObj.resourceUri == null)
		{
			//do nothing
		}
		else if (newHashObj.resourceUri != null &&
					(newHashObj.resourceUri != this._reviewUri) ||
					(newHashObj.ts && newHashObj.ts != this._ts))
		{
			this._reviewUri = newHashObj.resourceUri; 
			this._ts = newHashObj.ts;
			this.showReviewEditor();
		}
		if (this._reviewEditor != null)
		{
			var tab = newHashObj.tab;
			if (tab != null && tab != this._reviewEditor.getSelectedTabId())
			{
				this._reviewEditor.selectTab(tab);
			}
			//to trigger the population of the resources tab
			this._reviewEditor.resize();
		}
		
	},
	
		
	_handleWindowResize: function(event) {
		setTimeout(dojo.hitch(this, this.resize), 0);
	},
	
	resize: function() {
		/*Empty Block */
	},
	

	showStatusNode: function(text) {
		this.statusNode.innerHTML = "";
		if (text != null) {
			this.statusNode.appendChild(dojo.doc.createTextNode(text+"..."));	//$NON-NLS-1$
			this.statusNode.style.display= "inline";
		}else {
			this.statusNode.style.display= "none";			
		}
	},
	
	hideStatusNode: function() {
		this.statusNode.innerHTML = "";
		this.statusNode.style.display= "none";
	},
	

	
});



dojo.declare("com.ibm.rational.carter.ide.client.reviews.ReviewWidget._Mediator", null, {
	notifiers: null,

	constructor: function(){
		this.notifiers= [];
	},

	addNotifier: function(func){
		/*Checking for func being function or not is the caller responsability */
		this.notifiers.push(func);
	},

	removeNotifier: function(func){
		var index= dojo.indexOf(this.notifiers, func);
		if(index>-1){
			this.notifiers.splice(index, 1);
		}
	},

	execute: function(){
		for(var index=0; index<this.notifiers.length; index++){
			this.notifiers[index]();
		}
	}
});
})();
