/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
 
 function noError(){return true;}
 
(function() {
dojo.provide("com.ibm.rational.carter.ide.client.search.SearchWidget");
/*######################################### */
/*These imports are required to invoke auth dialogs, and
 * users' credentials checking utils. Otherwise, the users,
 * will not be autheroized when trying to search for an element
 * even if they are already logged in */
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");


dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojox.html");
dojo.require("com.ibm.rational.carter.ide.client.search.SearchController");
dojo.require("rmps.app.ui.internal.search.SearchResults");
dojo.require("rmps.app.ui.internal.search.QuickSearch");
dojo.require("dojo.string");
dojo.require("dijit.form.CheckBox");
dojo.require("dijit.form.RadioButton");
dojo.require("dijit._Widget");

dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.RemoteChooserResponder");

dojo.require("dojo.hash");

dojo.require("rmps.core.RootServices");


//reviews
//dojo.require("rmps.viewlets.internal.reviews.SimpleReviewDetails");
//dojo.require("rmps.viewlets.internal.reviews.ReviewsViewlet");

dojo.require("com.ibm.rational.carter.ide.client.connection.connectionWidget");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo");
dojo.requireLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

var RhpProjectAreaInfo = com.ibm.rational.carter.ide.client.internal.RhpProjectAreaInfo;
var rhpMessages = dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages");

dojo.require("com.ibm.rational.carter.ide.client.internal.RhpCommunicator");
var RhpCommunicator = com.ibm.rational.carter.ide.client.internal.RhpCommunicator;

/*
 * For now, we would like only to support RadioButton. We have some commented
 * code for the Picker to support nulti-selection; we could uncomment it when
 * needed 
 */
dojo.declare("com.ibm.rational.carter.ide.client.search.SearchWidget", [dijit._Widget, dijit._Templated], {
	
	"class": "root",
	
	messages: dojo.i18n.getLocalization("rmps.app.pickers", "RMPSPickerMessages"),
	rhpMessages : dojo.i18n.getLocalization("com.ibm.rational.carter.ide.client", "RhpClientMessages"),
	templateString: dojo.cache("com.ibm.rational.carter.ide.client", "search/templates/SearchWidget.html"),
	
	// private properties
	_controller: null,
	_searchResults: null,
	_quickSearch: null,
	//_remoteFrame: null,
	//_pickerArguments: null,
	_projectId: null,
	_selectedRows: [],
	_projectArea: null,
	
	_connectionWidget: null,
	
	constructor: function(params){
		window.onerror = noError;
    },
	
	buildRendering: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
	},
	
	postCreate: function() {
		

		//triggers the login window if needed
		
		if (RhpCommunicator.login() == false) {
			return;
		}
		
		var deferred = RhpProjectAreaInfo.init();
		deferred.addCallback(this,this.init);
		
	},

	initProjectAreaSelection: function(projectName){
		this._projectArea = RhpProjectAreaInfo.getProjectAreaByName(projectName);

		RhpCommunicator.notifyRhapsody({
				cmd: "projectareaselected",
				params: (this._projectArea != null)?[this._projectArea.name]:[],
			});

		if (this._projectArea != null) {
			this._quickSearch.setProjectArea(this._projectArea);
			this.quickSearch.style.visibility = "visible";
//			this.searchMessage.style.visibility = "visible";
		}
		else {
			this.quickSearch.style.visibility = "hidden";
//			this.searchMessage.style.visibility = "hidden";
			this._quickSearch.projectId = this._projectArea = null;
			this._quickSearch.setProjectArea(null);
		}

	},

			
	getFragment: function(attr) {
		var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		return fragment[attr];
	},

	init: function() {
		this._controller = new com.ibm.rational.carter.ide.client.search.SearchController(this);
		this._quickSearch = new rmps.app.ui.internal.QuickSearch_({
			projectId  : this._projectId,
			_controller: this._controller
			});
			
		this._quickSearch.setProjectArea(this._projectArea);
		this.quickSearch.appendChild(this._quickSearch.domNode);
		
		this.initProjectAreaSelection(this.getFragment("projectName"));	
		
		this._connectionWidget = new com.ibm.rational.carter.ide.client.connection.connectionWidget(
							{_clmWidget: this,});
		this.connectionContainer.appendChild(this._connectionWidget.domNode);
		dojo.connect(this._connectionWidget, "_onSelectProject",this,this.initProjectAreaSelection); 

		
	
		//subscribe to show in browser event.		
		 dojo.subscribe("rmps.web.app.explorer.show", this, function(resourceUri){
		 	if (resourceUri != null) {
				RhpCommunicator.notifyRhapsody({
					cmd: "ShowInExplorer",
					params:[resourceUri.uri]
				});
			}
 		});

		//subscribe on has change to catch pageSize changes
		dojo.subscribe("/dojo/hashchange", this, "onHashChange");
		
		//to run the search from the url fragment
		this.runSearchFromFragment(dojo.hash());
		//var args = {};
		//var details = new rmps.viewlets.internal.reviews.ReviewsViewlet(args);
		//this.connectionContainer.appendChild(details.domNode);
		//details.refresh();
	},
	onHashChange: function(hash) {
		this.runSearchFromFragment(hash);
	},
	//runs the search from the url fragment
	runSearchFromFragment: function(hash) {

		//var hash = dojo.hash();
		var fragment = dojo.queryToObject(hash);
		if (fragment.query != null) {
			var query = dojo.queryToObject(fragment.query);
			if (query.projectId != null) {
				var pa = RhpProjectAreaInfo.getProjectAreaById(query.projectId);

				if (pa != null) {
					var value = this._connectionWidget.projectSelector.attr('value',pa.name);
					this.initProjectAreaSelection(pa.name);
				}
				
			}
		}
		//TO DO: select the project in the drop down list	
		if (fragment.query != null)
			this._controller.search({query: fragment.query});
	},
	
//	_populateResultResponse: function(resultArray, returnMessage) {
//		var newItems= [];
//		if (resultArray) {
//			for (var i=0; i<resultArray.length; i++) {
//				var item = resultArray[i];	
//	   			var newItem= { "rdf:resource": item.link, "oslc:label" : item.name};
//	   			newItems.push(newItem);
//	   		}
//		}
//		var response= {
//			"oslc:message" : returnMessage,
//			"oslc:results" : newItems
//		};
//		
//		this._getRemoteFrameProtocol().sendResponse(dojo.toJson(response));
//	},
	
//	_getRemoteFrameProtocol: function(){
//		if(this._remoteFrame== null){
//			this._remoteFrame= new jazz.ui.RemoteChooserResponder();	
//		}
//		return this._remoteFrame;
//	},
	
//	onClickOKButton: function(e) {
//		var returnMessage = "oslc.select";
//		this._populateResultResponse(this._selectedRows,returnMessage);
//	},
//
//	onClickCancelButton: function(e) {
//		var emptyResponse= {"oslc:message" : "oslc.select", "oslc:results" : ""};		
//		this._populateResultResponse(emptyResponse);
//	},
		
	_handleWindowResize: function(event) {
		setTimeout(dojo.hitch(this, this.resize), 0);
	},
	
	resize: function() {
		/*Empty Block */
	},
	
	destroy: function() {
		if (this._searchResults) {
			
//			this._searchResults.domNode = this._searchResults.root;
			//alert ("startDestroy" + this._searchResults.root + this._searchResults.domNode);
			this._searchResults.destroy();
			//alert ("endDestroy");
			this._searchResults = null;
		}
		this.inherited(arguments);
		
	},
	
//	onCheckboxChange: function(rowConfig, checked){
//		if(checked) {
//			this._addSelectedRow(rowConfig);
//		} else {
//			this._removeSelectedRow(rowConfig);
//		}
////		this.okCmd.disabled= this._selectedRows.length <= 0;
//	},
	
//	_addSelectedRow : function (selectedRow) {
////		var rowIndex = this._findRow(selectedRow, this._selectedRows);
////		if (rowIndex == -1){
////			this._selectedRows.push(selectedRow);
//		this._selectedRows= [selectedRow];
////		}
//	},
	
//	_clearSelectedRows: function (selectedRow){
//		this._selectedRows= [];
//	},
//	
//	_removeSelectedRow: function (selectedRow){
//		var rowIndex = this._findRow(selectedRow, this._selectedRows);
//		if (rowIndex == -1){
//			return;
//		}
//		this._selectedRows.splice(rowIndex, 1);
//	},
//	
//	_findRow : function (selectedRow, selectedRowSet){		
//		for (var i=0; i<selectedRowSet.length; i++){
//			if (selectedRowSet[i].link == selectedRow.link){
//				return i;
//			}
//		}
//		return -1;
//	},
	
	showSearchResults: function(queryResults, preserveFilter) {
		if (!this._searchResults) { 
			this._searchResults = new rmps.app.ui.internal.search.SearchResults_({
					_quickSearch: this._quickSearch ,
					
					/*checkBoxes: this._selectedRows*/
					});
			this._searchResults.startup();
			this._searchResults.root = this._searchResults.domNode;	
			//this._searchResults._resultTable.onCheckboxChange = dojo.hitch(this , this.onCheckboxChange);
		}
		
//		if(queryResults.rawEntries.length){
//			this.controlArea.style.visibility= "visible";	
//		}else {
//			this.controlArea.style.visibility= "hidden";
//		}
//		this._searchResults.checkBoxes= this._selectedRows;
		this._searchResults.showResults(queryResults, preserveFilter);
		this.searchResults.appendChild(this._searchResults.domNode);
//		this._searchResults.destroy();
//		this._searchResults = null;
		
	},
	
	showStatusNode: function(text) {
		this.statusNode.innerHTML = "";
		if (text != null) {
			this.statusNode.appendChild(dojo.doc.createTextNode(text+"..."));	//$NON-NLS-1$
			this.statusNode.style.display= "inline";
		}else {
			this.statusNode.style.display= "none";			
		}
	},
	
	hideStatusNode: function() {
		this.statusNode.innerHTML = "";
		this.statusNode.style.display= "none";
	},
	
});



dojo.declare("rmps.app.ui.internal.search.SearchResults_", rmps.app.ui.internal.search.SearchResults, {
	
	tableClass: "rmps.app.ui.internal.search._TableEx",
	_quickSearch: null,
	_machingLabel: null,
	checkBoxes: null,
	messages: dojo.i18n.getLocalization("rmps.app.pickers", "RMPSPickerMessages"),
	
	createTable: function() {
		var table= this.inherited(arguments);
		table._quickSearch= this._quickSearch;
		return table;
	},
	
	//setTitleNode: function(queryResult, titleNode){
	setTitleNode: function(queryResult){
		if(!this._machingLabel){
			var title = "Matching Model Elements for '" + queryResult.query.text + "': ";
			this._machingLabel= dojo.doc.createTextNode(title);
			this._titleNode.appendChild(this._machingLabel);
			this._titleNode.style.fontSize= "medium";
			this._titleNode.style.fontWeight= "bold";
			this._started= true;
		}
	},
	
	setDescriptionNode: function(queryResult){
		this.inherited(arguments);//dojo.html._emptyNode(this._descriptionNode);
		
	}
	
	
});


dojo.declare("rmps.app.ui.internal.search._TableEx", rmps.app.ui.internal.search._Table, {
	
	_quickSearch: null,
	_idToIdx: {},
	_baseLinkUri: null,
	
	_populateTableBody: function() {
		
		if (this._quickSearch != null && this._quickSearch._projectArea != null)
		{
			var PROJECT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "projects");
			PROJECT_PATH = PROJECT_PATH.replace("projects","web/projects");
			this._baseLinkUri = PROJECT_PATH + "/" + this._quickSearch._projectArea.name;
		}
		this.inherited(arguments);
	},
	
	_populateColumn: function(rowConfig, tableRow, rowIdx, columnConfig, tableCell, colIdx) {

		this.inherited(arguments);
		if (columnConfig.link) {
			var span = tableCell.lastChild;
			var link = span.lastChild;
			var href = new String(link.href);
			href = href.substring(href.lastIndexOf('#'), href.length);
			link.href = this._baseLinkUri + (href);
		}

	},
	
	_handleTbodyMouseClick: function(e) {
		/*We do not allow navigation for the table links in the picker */
		return;
	},
	
//	onCheckboxChange: function(rowConfig, checked){
//		/*Do Nothing */
//	},
	
	//_constructPageSizeDropDown: function() {
		//this.inherited();
		/*we do not want to allow the user to change the value of the number of the displayed entries;
		 * this is in order to avoid having any layout problems in the Resource Picker in which will added
		 * in other contents */
		//this._pageSizeSelect.style.display= "visible";
		//this._itemsPerPage.style.display= "visible";
	//},
	
	onPreviousClick: function(e) {
		dojo.stopEvent(e);
		this.doQuery(this.pagingControl.page-1, this.pagingControl.pageSize);
	},
	
	onNextClick: function(e) {
		dojo.stopEvent(e);
		this.doQuery(this.pagingControl.page+1, this.pagingControl.pageSize);
	},
	
	doQuery: function(page, pageSize){
		var query= this.createQuery(page, pageSize);
		var queryString= query.toQueryString();
		var timestamp = new Date().getTime();
		this._quickSearch.doQuery(query);
	},
	
	createQuery:function(page, pageSize){
		var queryResult = this.pagingControl.table.search.getQueryResult();
		var query = dojo.clone(queryResult.query);
		query.pageSize = pageSize;
		query.page = page;
		query.token = query.id;
		return query;
	},
	

	
		

});


dojo.declare("rmps.app.ui.internal.QuickSearch_", rmps.app.ui.internal.search.QuickSearch, {
	
    _controller: null,
	pageSize: 5,
	resourcesOnly: false,
	_projectArea: null,

	setProjectArea: function(pa)
	{
		this._projectArea = pa;
		this.projectId = (pa != null) ? pa.itemId: null;
	},
	doQuery: function(query) {
		this._controller.search({query: query.toQueryString()});
	}
});

})();
